<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/05/04 12:37
 */
namespace api\controllers;

use common\classes\Common;
use common\classes\Error;
use Yii;
use yii\helpers\ArrayHelper;

/**
 * Datetime controller
 */
class DatetimeController extends BaseController
{
    public function actionView(){
        return Yii::$app->udp->system($this->id, $this->action->id, null);
    }

    public function actionZoneList(){
        $zonelist = ["Africa", "America", "Antarctica", "Arctic", "Asia", "Atlantic", "Australia", "Europe", "Indian", "Pacific"];
        $timezone = [];
        foreach (timezone_abbreviations_list() as $item) {
            foreach ($item as $val) {
                if (isset($val['timezone_id'])) {
                    $zone = preg_split('/\//', $val['timezone_id']);
                    if (!$zone || count($zone) < 2)
                        continue;
                    if (in_array($zone[0], $zonelist))
                        $timezone[$zone[0]][] = trim($zone[1]);
                }
            }
        }
        foreach ($timezone as $area => $list) {
            $list = array_unique($list);
            foreach ($list as $key => $value) {
                $file = Common::ZONEINFO_PATH . $area . '/' . $value;
                if (!file_exists($file)) {
                    unset($list[$key]);
                    continue;
                }
                $type = filetype($file);
                if ($type != 'file' && $type != 'link')
                    unset($list[$key]);
            }
            $timezone[$area] = array_values(array_unique($list));
        }
        return $this->response(Error::STATUS_SUCCESS, $timezone);
    }

    public function actionUpdate(){
        $data = Yii::$app->request->post('data');
        if(empty($data))
            return $this->response(Error::STATUS_PARAM_ERROR);
        if(isset($data['reboot']) && $data['reboot'] == true) {
            $log = $this->writeLog(Error::STATUS_SUCCESS, null);
            $this->logSended = true;
        }
        else
            $log = null;
        $ret = Yii::$app->udp->system($this->id, $this->action->id, $data, 15);
        if(!empty($log))
            $this->logChange($log, 'result', Error::STATUS_FAILED);
        return $ret;
    }
}