<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/5/15 17:20
 */
namespace api\controllers;

use common\classes\Error;
use common\models\Event;
use common\models\EventModel;
use common\models\PlaySessions;
use common\models\VEvent;
use Yii;

/**
 * Event controller
 */
class EventController extends BaseController
{
    public function actionModelList() {
        $list = EventModel::find()->all();
        return $this->response(Error::STATUS_SUCCESS, ['count' => count($list), 'list' => $list]);
    }

    public function actionList() {
        $list = VEvent::find()->all();
        return $this->response(Error::STATUS_SUCCESS, ['count' => count($list), 'list' => $list]);
    }

    public function actionDelete($id) {
        $model = Event::findOne(['Id' => $id]);
        if(empty($model))
            return $this->response(Error::STATUS_EVENT_NOT_EXISTS);
        else if($model->delete())
            return $this->response(Error::STATUS_SUCCESS);
        else
            return $this->response(Error::STATUS_FAILED);
    }

    private function eventNP($model) {
        $data = Yii::$app->request->post('data');
        if(empty($data) || ($model->isNewRecord && !isset($data['StartTask']) && !isset($data['EndTask'])))
            return $this->response(Error::STATUS_PARAM_ERROR);
        if((isset($data['StartTask']) && PlaySessions::find()->where(['SessionID' => $data['StartTask']])->count() != 1) ||
            (isset($data['EndTask']) && PlaySessions::find()->where(['SessionID' => $data['EndTask']])->count() != 1))
            return $this->response(Error::STATUS_EVENT_SESSION_NOT_EXISTS);

        if($model->load(Yii::$app->request->post(), 'data') && $model->save()) {
            $model = VEvent::findOne(['Id' => $model->Id]);
            return $this->response(Error::STATUS_SUCCESS, $model);
        }
        else
            return $this->response(Error::STATUS_FAILED);
    }
    public function actionNew() {
        $model = new VEvent();
        return $this->eventNP($model);
    }

    public function actionUpdate($id) {
        $model = VEvent::findOne(['Id' => $id]);
        if(empty($model))
            return $this->response(Error::STATUS_EVENT_NOT_EXISTS);
        return $this->eventNP($model);
    }
}
