<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/4/28 10:37
 */
namespace api\controllers;
use common\classes\Error;
use common\models\ProjectorType;
use Yii;

/**
 * Projector controller
 */
class ProjectorController extends BaseController
{
    public function actionList(){
        $models = ProjectorType::find()->all();
        return $this->response(Error::STATUS_SUCCESS, $models);
    }

    public function actionNew(){
        $data = Yii::$app->getRequest()->post('data');
        if(empty($data) || empty($data['Type']))
            return $this->response(Error::STATUS_PARAM_ERROR);
        $this->logTitle['title1'] = $data['Type'];
        $count = ProjectorType::find()->where(['Type' => $data['Type']])->count();
        if($count > 0)
            return $this->response(Error::STATUS_PROJECTOR_EXIST);
        if(empty($data['CmdOpen']) || !ctype_xdigit($data['CmdOpen']) ||
            empty($data['CmdClose']) || !ctype_xdigit($data['CmdOpen']) ||
            (!empty($data['CmdFromPc']) && !ctype_xdigit($data['CmdFromPc'])) ||
            (!empty($data['CmdFromVideo']) && !ctype_xdigit($data['CmdFromVideo'])))
            return $this->response(Error::STATUS_FAILED);
        $model = new ProjectorType();
        if($model->load(Yii::$app->getRequest()->post(), 'data') && $model->save()) {
            Yii::$app->udp->system($this->id, $this->action->id, $model->toArray());
            return $this->response(Error::STATUS_SUCCESS, $model);
        }
        return $this->response(Error::STATUS_FAILED);
    }

    public function actionUpdate($type){
        $data = Yii::$app->getRequest()->post('data');
        if(empty($data))
            return $this->response(Error::STATUS_PARAM_ERROR);
        $this->logTitle['title1'] = $type;
        if(empty($data['CmdOpen']) || !ctype_xdigit($data['CmdOpen']) ||
            empty($data['CmdClose']) || !ctype_xdigit($data['CmdOpen']) ||
            (!empty($data['CmdFromPc']) && !ctype_xdigit($data['CmdFromPc'])) ||
            (!empty($data['CmdFromVideo']) && !ctype_xdigit($data['CmdFromVideo'])))
            return $this->response(Error::STATUS_FAILED);
        $model = ProjectorType::findOne(['Type' => $type]);
        if(empty($model))
            return $this->response(Error::STATUS_PROJECTOR_NOT_EXIST);
        if($model->load(Yii::$app->getRequest()->post(), 'data') && $model->save())
            return $this->response(Error::STATUS_SUCCESS, $model);
        return $this->response(Error::STATUS_FAILED);
    }

    public function actionDelete($type){
        $this->logTitle['title1'] = $type;
        ProjectorType::deleteAll(['Type' => $type]);
        return $this->response(Error::STATUS_SUCCESS);
    }
}
