<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/05/08 11:37
 */
namespace api\controllers;

use common\models\VPlayingSessions;
use common\classes\Error;
use common\models\VSession;

/**
 * Session Base controller
 */
class SessionBaseController extends BaseController
{
    public function getSessionList($query, $param) {
        if (($this->serverPri & 0x06) == 0)
            $query = $query->andWhere(['Type' => 'ctrl']);
        else if(($this->serverPri & 0x04) == 0)
            $query = $query->andWhere(['or', ['StreamType' => null], ['StreamType' => 0], ['StreamType' => 1], ['StreamType' => 128], ['StreamType' => 129]]);
        $count = $this->listQuery($query, $param);
        $lists = $query->all();
        $sessions = [];
        $status = [];
        foreach ($lists as $list)
            $sessions[] = $list->SessionID;

        if(count($sessions) > 0) {
            $status = VPlayingSessions::find()->select(['SessionID', 'FileName', 'CurrTotalProgress', 'Weekday', 'Pause', 'PlayTime'])
                ->where(['in', 'SessionID', $sessions])
                ->all();
        }
        return $this->response(Error::STATUS_SUCCESS, ['count' => $count, 'list' => $lists, 'status' => $status]);
    }
}
