<?php
namespace api\controllers;

use common\classes\Common;
use common\models\BaseInfo;
use Yii;
use yii\filters\VerbFilter;
use common\classes\Error;
use yii\helpers\ArrayHelper;

/**
 * Site controller
 */
class SupportController extends BaseController
{
    public function actionUpdate($state){
        if($state !== 'on')
            $state = 'off';
        $this->logTitle['title1'] = $state == 'on' ? 'start' : 'stop';
        $data = Yii::$app->request->post('data');
        if(is_null($data) || empty($data['description']))
            $description = null;
        else
            $description = $data['description'];
        return Yii::$app->udp->system($this->id, $this->action->id, ['state' => $state, 'description' => $description, 'uid' => 0]);
    }

    public function actionView(){
        $info = BaseInfo::findOne(['InfomationID' => Common::BASEINFO_SUPPORT_STATE]);
        if(!empty($info) && !empty($info->InfoValue)) {
            $ret = [
                'state' => 'on',
                'startAt' => date('Y-m-d H:i:s', $info->InfoValue)
            ];
        }
        else
            $ret = [
                'state' => 'off'
            ];
        return $this->response(Error::STATUS_SUCCESS, $ret);
    }
}
