<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "DeviceStatus".
 *
 * @property string $DeviceID
 * @property integer $DeviceType
 * @property integer $DeviceStatus
 * @property string $IpAddress
 * @property integer $ShouldSessionID
 * @property integer $ActualSessionID
 * @property integer $State_SysPower
 * @property integer $State_ProjectorStatus
 * @property integer $State_ProjectorLampStatus
 * @property integer $State_ExDevice1Status
 * @property integer $State_ExDevice2Status
 * @property integer $State_CurrProjectorSrc
 * @property integer $State_CurrAudio
 * @property integer $State_CurrAudioVolume
 * @property integer $State_CurrMicVolume
 * @property integer $State_FaultStatus
 * @property integer $State_MicState
 * @property integer $State_Mute
 * @property integer $State_CentralUsedTime
 * @property integer $State_ProjectorUsedTime
 * @property integer $State_LightUsedTime
 * @property integer $Cfg_System
 * @property resource $Cfg_Remark
 * @property integer $netid
 * @property integer $NetworkID
 * @property integer $BrdPort
 * @property string $RfDevStatus
 * @property integer $State_Pc
 * @property integer $User_ID
 * @property integer $SysPowerCmd
 * @property integer $IpCallStatus
 * @property string $RfDevCmd
 */
class DeviceStatus extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'DeviceStatus';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['DeviceID'], 'required'],
            [['DeviceType', 'DeviceStatus', 'ShouldSessionID', 'ActualSessionID', 'State_SysPower', 'State_ProjectorStatus', 'State_ProjectorLampStatus', 'State_ExDevice1Status', 'State_ExDevice2Status', 'State_CurrProjectorSrc', 'State_CurrAudio', 'State_CurrAudioVolume', 'State_CurrMicVolume', 'State_FaultStatus', 'State_MicState', 'State_Mute', 'State_CentralUsedTime', 'State_ProjectorUsedTime', 'State_LightUsedTime', 'Cfg_System', 'netid', 'NetworkID', 'BrdPort', 'State_Pc', 'User_ID', 'SysPowerCmd', 'IpCallStatus'], 'integer'],
            [['DeviceID', 'IpAddress'], 'string', 'max' => 50],
            [['Cfg_Remark'], 'string', 'max' => 96],
            [['RfDevStatus', 'RfDevCmd'], 'string', 'max' => 16],
            [['DeviceID'], 'unique'],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'DeviceID' => 'Device ID',
            'DeviceType' => 'Device Type',
            'DeviceStatus' => 'Device Status',
            'IpAddress' => 'Ip Address',
            'ShouldSessionID' => 'Should Session ID',
            'ActualSessionID' => 'Actual Session ID',
            'State_SysPower' => 'State  Sys Power',
            'State_ProjectorStatus' => 'State  Projector Status',
            'State_ProjectorLampStatus' => 'State  Projector Lamp Status',
            'State_ExDevice1Status' => 'State  Ex Device1 Status',
            'State_ExDevice2Status' => 'State  Ex Device2 Status',
            'State_CurrProjectorSrc' => 'State  Curr Projector Src',
            'State_CurrAudio' => 'State  Curr Audio',
            'State_CurrAudioVolume' => 'State  Curr Audio Volume',
            'State_CurrMicVolume' => 'State  Curr Mic Volume',
            'State_FaultStatus' => 'State  Fault Status',
            'State_MicState' => 'State  Mic State',
            'State_Mute' => 'State  Mute',
            'State_CentralUsedTime' => 'State  Central Used Time',
            'State_ProjectorUsedTime' => 'State  Projector Used Time',
            'State_LightUsedTime' => 'State  Light Used Time',
            'Cfg_System' => 'Cfg  System',
            'Cfg_Remark' => 'Cfg  Remark',
            'netid' => 'Netid',
            'NetworkID' => 'Network ID',
            'BrdPort' => 'Brd Port',
            'RfDevStatus' => 'Rf Dev Status',
            'State_Pc' => 'State  Pc',
            'User_ID' => 'User  ID',
            'SysPowerCmd' => 'Sys Power Cmd',
            'IpCallStatus' => 'Ip Call Status',
            'RfDevCmd' => 'Rf Dev Cmd',
        ];
    }
}
