<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "v_device_message".
 *
 * @property integer $message
 * @property string $id
 * @property string $name
 * @property integer $parent
 * @property string $description
 * @property string $ipaddress
 * @property integer $shouldSession
 * @property integer $actualSession
 * @property string $sessionName
 * @property string $power
 * @property string $projector
 * @property string $projectorLamp
 * @property string $exDevice1
 * @property string $exDevice2
 * @property string $projectorSrc
 * @property string $audioSrc
 * @property integer $audioVol
 * @property integer $micVol
 * @property integer $fault
 * @property string $micMute
 * @property string $audioMute
 * @property string $pc
 * @property string $iotStatus
 * @property string $userName
 * @property string $ipcall
 */
class VDeviceMessage extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'v_device_message';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['message', 'parent', 'shouldSession', 'actualSession', 'audioVol', 'micVol', 'fault'], 'integer'],
            [['id', 'ipaddress', 'sessionName'], 'string', 'max' => 50],
            [['name', 'iotStatus'], 'string', 'max' => 32],
            [['description'], 'string', 'max' => 96],
            [['power', 'ipcall'], 'string', 'max' => 7],
            [['projector'], 'string', 'max' => 8],
            [['projectorLamp', 'exDevice1', 'exDevice2'], 'string', 'max' => 4],
            [['projectorSrc', 'audioSrc'], 'string', 'max' => 10],
            [['micMute', 'audioMute', 'pc'], 'string', 'max' => 3],
            [['userName'], 'string', 'max' => 255],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'message' => 'Message',
            'id' => 'ID',
            'name' => 'Name',
            'parent' => 'Parent',
            'description' => 'Description',
            'ipaddress' => 'Ipaddress',
            'shouldSession' => 'Should Session',
            'actualSession' => 'Actual Session',
            'sessionName' => 'Session Name',
            'power' => 'Power',
            'projector' => 'Projector',
            'projectorLamp' => 'Projector Lamp',
            'exDevice1' => 'Ex Device1',
            'exDevice2' => 'Ex Device2',
            'projectorSrc' => 'Projector Src',
            'audioSrc' => 'Audio Src',
            'audioVol' => 'Audio Vol',
            'micVol' => 'Mic Vol',
            'fault' => 'Fault',
            'micMute' => 'Mic Mute',
            'audioMute' => 'Audio Mute',
            'pc' => 'Pc',
            'iotStatus' => 'Iot Status',
            'userName' => 'User Name',
            'ipcall' => 'Ipcall',
        ];
    }
}
