<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/08/18 10:54
 */
namespace Workerman\iDste;
use common\models\BaseInfo;
use common\models\SystemLog;
use Workerman\Worker;
use Yii;

use Workerman\Lib\Timer;
use yii\db\Exception;
require_once __DIR__ . '/../Autoloader.php';
require_once  __DIR__ . '/../../common/classes/System.php';
require_once  __DIR__ . '/../../common/classes/Error.php';

class TimetableDaemon
{
    public function __construct($deamon){
        $deamon->onWorkerStart = [$this, 'workerStart'];
    }

    public function workerStart($worker){
        Timer::add(1, [$this, 'plan']);
    }

    public function log($msg){
        $fp = fopen("../idste_timetable_adapter.log", "a");
        $msg = date('Y-m-d H:i:s') . "$msg\n";
        fwrite($fp, $msg);
        fclose($fp);
    }

    public function dbReconnect()
    {
        while (true) {
            try {
                Yii::$app->db->close();
                Yii::$app->db->open();
                return;
            } catch (Exception $e) {
                echo "db error, wait. \n";
                sleep(1);
            }
        }
    }

    public function plan(){
        $this->dbReconnect();
        $bi = BaseInfo::findOne(['InfomationID' => 0x11a]);
        if(empty($bi) || is_null($bi->InfoValue) || $bi->InfoValue < 0)
            $ahead = 0;
        else
            $ahead = $bi->InfoValue;
        $bi = BaseInfo::findOne(['InfomationID' => 0x11b]);
        if(empty($bi) || is_null($bi->InfoValue) || $bi->InfoValue < 0)
            $delay = 0;
        else
            $delay = $bi->InfoValue;
        $aheadLow = floor($ahead - 5);
        $sql = "UPDATE DeviceStatus a, Timetable b SET a.SysPowerCmd = 1 WHERE a.DeviceID = b.DevId AND
                ((b.`Type` = 'normal' and TIMESTAMPDIFF(SECOND, TIME(NOW()), TIME(b.Start)) <= $ahead AND TIMESTAMPDIFF(SECOND, TIME(NOW()), TIME(b.Start)) > $aheadLow AND b.Weekday = WEEKDAY(NOW()) OR
                ( b.`Type` = 'temporary' and TIMESTAMPDIFF(SECOND, NOW(), b.Start) >= 0 and TIMESTAMPDIFF(SECOND, NOW(), b.Start) < 5 )));";
        Yii::$app->db->createCommand($sql)->execute();
        $sql = "SELECT group_concat(DevId) as ids FROM Timetable b WHERE
               ( `Type` = 'normal' and TIMESTAMPDIFF(SECOND, TIME(NOW()), TIME(b.`start`)) <= $ahead AND TIMESTAMPDIFF(SECOND, TIME(b.End), TIME(NOW())) < $delay AND b.Weekday = WEEKDAY(NOW())) OR
               ( `Type` = 'temporary' and TIMESTAMPDIFF(SECOND, b.`start`, NOW()) >= 0 AND TIMESTAMPDIFF(SECOND, b.End, NOW()) < 0);";
        $devs = Yii::$app->db->createCommand($sql)->queryAll();
        $delayHigth = floor($delay + 5);
        if(empty($devs) || !isset($devs['ids'])) {
            $sql = "UPDATE DeviceStatus a, Timetable b SET a.SysPowerCmd = 0 WHERE b.DevId = a.DeviceID AND
                   ((b.`Type` = 'normal' AND TIMESTAMPDIFF(SECOND, TIME(b.End), TIME(NOW())) < $delayHigth AND TIMESTAMPDIFF(SECOND, TIME(b.End), TIME(NOW())) >= $delay AND b.Weekday = WEEKDAY(NOW())) OR
                    (b.`Type` = 'temporary' AND TIMESTAMPDIFF(SECOND, b.End, NOW()) < 5 AND TIMESTAMPDIFF(SECOND, b.End, NOW()) >= 0)); ";
            Yii::$app->db->createCommand($sql)->execute();
        }
        else {
            $sql = "UPDATE DeviceStatus a, Timetable b SET a.SysPowerCmd = 0 WHERE b.DevId = a.DeviceID AND
                   ((b.`Type` = 'normal' AND TIMESTAMPDIFF(SECOND, TIME(b.End), TIME(NOW())) < $delayHigth AND TIMESTAMPDIFF(SECOND, TIME(b.End), TIME(NOW())) >= $delay AND b.Weekday = WEEKDAY(NOW())) OR
                    (b.`Type` = 'temporary' AND TIMESTAMPDIFF(SECOND, b.End, NOW()) < 5 AND TIMESTAMPDIFF(SECOND, b.End, NOW()) >= 0)) AND
                     b.DevId not in (" .$devs['ids'] . ");";
            Yii::$app->db->createCommand($sql)->execute();
        }
    }
}
