-- MySQL Workbench Forward Engineering

SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='TRADITIONAL,ALLOW_INVALID_DATES';

-- -----------------------------------------------------
-- Schema mydb
-- -----------------------------------------------------
-- -----------------------------------------------------
-- Schema nccs
-- -----------------------------------------------------

-- -----------------------------------------------------
-- Schema nccs
-- -----------------------------------------------------
CREATE SCHEMA IF NOT EXISTS `nccs` DEFAULT CHARACTER SET utf8 ;
USE `nccs` ;
USE `nccs` ;

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_DeviceModes`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_DeviceModes` (`DeviceID` INT, `BrdModeID` INT, `Priority` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_Session_Files`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_Session_Files` (`SessionID` INT, `SessionName` INT, `FileID` INT, `SequenceID` INT, `FileName` INT, `TotalTime` INT, `PlayTime` INT, `Gain` INT, `FileFmt` INT, `FilePath` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_active_mode_members`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_active_mode_members` (`DeviceID` INT, `BrdModeID` INT, `Priority` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_device`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_device` (`id` INT, `name` INT, `parent` INT, `description` INT, `ipaddress` INT, `shouldSession` INT, `actualSession` INT, `version` INT, `sessionName` INT, `power` INT, `projector` INT, `projectorLamp` INT, `exDevice1` INT, `exDevice2` INT, `projectorSrc` INT, `audioSrc` INT, `audioVol` INT, `micVol` INT, `fault` INT, `micMute` INT, `audioMute` INT, `pc` INT, `iotStatus` INT, `userName` INT, `ipcall` INT, `ModeName` INT, `ModePriority` INT, `rtsp` INT, `rtsp1` INT, `ProjAlert` INT, `Temperature` INT, `Humidity` INT, `pcCtrl` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_device_classes`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_device_classes` (`ClassID` INT, `Name` INT, `Parent` INT, `DevID` INT, `Dev_Name` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_device_log`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_device_log` (`DevLogID` INT, `DeviceID` INT, `DeviceName` INT, `DateTime` INT, `Event` INT, `CtrlUser` INT, `User_Name` INT, `User_Sn` INT, `MsgContext` INT, `EndTime` INT, `Length` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_device_message`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_device_message` (`message` INT, `id` INT, `name` INT, `parent` INT, `description` INT, `ipaddress` INT, `shouldSession` INT, `actualSession` INT, `sessionName` INT, `power` INT, `projector` INT, `projectorLamp` INT, `exDevice1` INT, `exDevice2` INT, `projectorSrc` INT, `audioSrc` INT, `audioVol` INT, `micVol` INT, `fault` INT, `micMute` INT, `audioMute` INT, `pc` INT, `iotStatus` INT, `userName` INT, `ipcall` INT, `ModeName` INT, `Temperature` INT, `Humidity` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_device_statistic`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_device_statistic` (`DeviceID` INT, `DeviceName` INT, `StatisticDay` INT, `power0` INT, `power1` INT, `power2` INT, `power3` INT, `power4` INT, `power5` INT, `power6` INT, `power7` INT, `power8` INT, `power9` INT, `power10` INT, `power11` INT, `power12` INT, `power13` INT, `power14` INT, `power15` INT, `time0` INT, `time1` INT, `time2` INT, `time3` INT, `time4` INT, `time5` INT, `time6` INT, `time7` INT, `time8` INT, `time9` INT, `time10` INT, `time11` INT, `time12` INT, `time13` INT, `time14` INT, `time15` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_event`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_event` (`Id` INT, `Name` INT, `StartTask` INT, `StartTaskName` INT, `EndTask` INT, `EndTaskName` INT, `Config` INT, `Model` INT, `Manufacturer` INT, `ModelName` INT, `Version` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_ip_call`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_ip_call` (`id` INT, `device` INT, `deviceName` INT, `waiter` INT, `waiterName` INT, `audioPort` INT, `ringing` INT, `status` INT, `direction` INT, `webrtcUpdate` INT, `webrtcStatus` INT, `wsPort` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_media_files`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_media_files` (`MediaID` INT, `FileName` INT, `FileSize` INT, `TotalTime` INT, `FileFmt` INT, `BitRate` INT, `VedioCodec` INT, `Height` INT, `Width` INT, `FrameRate` INT, `AudioCodec` INT, `Channels` INT, `SampleRate` INT, `Parent` INT, `Gain` INT, `CreateTime` INT, `FilePath` INT, `Owner` INT, `OwnerName` INT, `Sysfolder` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_play_session_time_group`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_play_session_time_group` (`id` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_player_keys`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_player_keys` (`PlayerKeyId` INT, `PlayerID` INT, `Index` INT, `GroupDisable` INT, `DevDisable` INT, `GroupID` INT, `GroupName` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_playing_sessions`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_playing_sessions` (`SessionID` INT, `PlayerID` INT, `PlayingFileID` INT, `FileName` INT, `MultiPort` INT, `CircleLength` INT, `CurrFileProgress` INT, `CurrTotalProgress` INT, `Priority` INT, `Pause` INT, `ScheduleID` INT, `WeekDay` INT, `PlayTime` INT, `Template` INT, `BrdMode` INT, `SessionType` INT, `StreamType` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_session_info`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_session_info` (`SessionID` INT, `SessionName` INT, `SessionType` INT, `Priority` INT, `CircleLength` INT, `PlayerID` INT, `BrdMode` INT, `MemberMode` INT, `StreamType` INT, `SysEnabled` INT, `RfDevCtrl` INT, `Owner` INT, `OwnerName` INT, `PlayMode` INT, `AudioGain` INT, `Template` INT, `FileID` INT, `PlayerAddress` INT, `PlayType` INT, `PlayerType` INT, `Type` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_session_schedules`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_session_schedules` (`ScheduleID` INT, `TempFlag` INT, `PlayTime` INT, `WeekDay` INT, `SessionID` INT, `SessionName` INT, `Pause` INT, `BrdMode` INT, `SessionType` INT, `SysEnabled` INT, `RfDevCtrl` INT, `StreamType` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_stream_trans_table`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_stream_trans_table` (`NetworkID` INT, `proxy` INT, `IpAddress` INT, `MultiPort` INT, `SessionID` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_timed_session_info`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_timed_session_info` (`SessionID` INT, `SessionName` INT, `SessionType` INT, `Priority` INT, `BrdMode` INT, `StreamType` INT, `Owner` INT, `OwnerName` INT, `PlayMode` INT, `Template` INT, `FileID` INT, `PlayTime` INT, `WeekDay` INT, `TempFlag` INT, `ScheduleID` INT, `Type` INT);

-- -----------------------------------------------------
-- Placeholder table for view `nccs`.`v_timetable`
-- -----------------------------------------------------
CREATE TABLE IF NOT EXISTS `nccs`.`v_timetable` (`Id` INT, `DevId` INT, `Dev_Name` INT, `UserId` INT, `User_Name` INT, `WeekDay` INT, `Start` INT, `End` INT, `Type` INT, `OneTime` INT, `Sync` INT);

-- -----------------------------------------------------
-- procedure delete_task
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`delete_task`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `delete_task`(taskid int)
begin
declare ses_id smallint default null;
select  SessionID into ses_id from PlaySessionTime where ScheduleID = taskid;

if (ses_id is not null) then
    call sp_session_ctrl(ses_id, 0, taskid);
end if;

Delete from PlaySessionTime where ScheduleID = taskid;

end$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_IcCard_Authorize
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_IcCard_Authorize`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `func_IcCard_Authorize`(
          IcCard varchar(50),
          DeviceID varchar(50)
         ) RETURNS int(11)
BEGIN
    declare uid int default null; 
    declare tt int default null; 
    declare udid int default null; 
    declare tid int default null;  
    declare nowday INT default null; 
    declare card varchar(10) default null; 
    declare cardHex varchar(10) default null; 
    declare cardSwitch varchar(10) default null; 

    set card = LPAD(ltrim(rtrim(IcCard)), 10, 0);
    set cardHex = LPAD(conv(IcCard,10, 16), 8, 0);
    set cardHex = concat(substring(cardHex, 7,2), substring(cardHex, 5, 2), substring(cardHex, 3, 2), substring(cardHex, 1, 2));
    set cardSwitch = LPAD(conv(cardHex, 16, 10), 10, 0);

    set @isMgr = false;
    select User_ID, Dev_Privilege, Mgr_Privilege, User_Name, Pass_Word, Privilege into uid, @dpri, @mpri, @username, @passwd, @privilege from Users
                    where ( LPAD(ltrim(rtrim(Users.IcCard)), 10, 0) = card or
                            LPAD(ltrim(rtrim(Users.IcCard)), 10, 0) = cardSwitch
                          ) and
                          Users.IC_Status=0 and 
                          (Users.User_Expiry is null or 
                           Users.User_Expiry > now());
    if(uid is null )then
        return null;
    elseif(uid=0) or (@dpri=1)then
        return uid;
    elseif(@username is not null) and (@passwd is not null) then
        if(@privilege&0x40000000 = 0x40000000) then
            return uid;
        end if;
        if(@privilege&1 = 1) then
            if(@mpri = 1) then
                return uid;
            end if;
            set @isMgr = true;
        end if;
    end if;
    
    select a.UserDevID into udid from UserDevices a
				  left join Users b on b.User_ID = uid
                  where a.UserID = uid and
                        a.DevID = DeviceID and
                        (
                            (a.Pri&1=1 and
                                (
                                    (
                                        b.User_Type=3 and
                                        (
                                            b.User_Expiry is null or
                                            b.User_Expiry > now()
                                        )
                                    ) or
                                    b.User_Type <3
                                )
                            ) or
                            ((@isMgr=true) and (a.Pri&2=2))
                        )
                  LIMIT 1;
	
	
    if(udid is not null) then
		return uid;
    end if;
    
    select InfoValue into tt from BaseInfo where InfomationID=280;
    if(tt is null) or (tt <= 0) then
		return null;
    end if;
    
    select AlteredScheduleDay into nowday from AlternateDate where `SpecialDate` = DATE(now());
    if(nowday is null) then
 		set nowday = WEEKDAY(now());
 	end if;
	
    
    select `Id` into tid from Timetable 
					where 	`UserID` = uid and
							`DevId` = DeviceID and
                            (
                                `OneTime` = 0 and
                                `WeekDay` = nowday and
                                time(now()) > subtime(time(`Start`), '00:30:00') and
                                time(now()) < time(`End`)
                            ) or
                            (
                                `OneTime` = 1 and
                                now() > subtime(`Start`, '00:30:00') and
                                now() < `End`
                            )
					limit 1;
		
	if (tid is not null) then
        return uid;
	end if;
    return null;    
END$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_check_dev_stream
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_check_dev_stream`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `func_check_dev_stream`( 
                                    dev_id varchar(50),
                                    stream_type int) RETURNS tinyint(1)
begin

if (ASCII(dev_id) = 0x30) then
     return false;
end if;    

if ((stream_type & 0x02)  <> 0) then
    if (ASCII(right(dev_id, 9)) <> 0x38) then
         return false;
     end if;    
end if;

return true;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_check_mode_daytime
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_check_mode_daytime`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `func_check_mode_daytime`( 
          weekday tinyint, 
          checked_time datetime,
          last_time datetime,
          cur_time datetime
         ) RETURNS tinyint(1)
begin
declare cur_weekday tinyint default null;
declare checked_date date;


if (last_time >= cur_time) then
    return false;
end if;    


if  (weekday = 0) then

    if (checked_time  > last_time) and (checked_time <= cur_time) then 
        return true;
    end if;    
else
    
     if (time(last_time) > time(cur_time)) then
         
         if (time(checked_time) > time(last_time) ) then
              set checked_date = date(last_time);
         else 
              if (time(checked_time) <= time(cur_time)) then
                    set checked_date = date(cur_time);
              else
                    return false;
               end if ;    
          end if;
      else
          
          if (time(checked_time) <= time(last_time) )  or 
              (time(checked_time) > time(cur_time))  then
              
              return false;
           end if;   
           
           set checked_date = date(cur_time);
      end if;
      
       
      select AlteredScheduleDay into cur_weekday from AlternateDate where SpecialDate = checked_date;

      if cur_weekday is null then 
           set cur_weekday = weekday(checked_date);
       end if;
     
    if (weekday & (0x01 << cur_weekday)  <> 0 ) then 
        
        return true;
   end if;    
end if;

return false;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_check_mode_enabled
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_check_mode_enabled`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `func_check_mode_enabled`( modeid int , 
      PlayTime time,
      PlayDate date) RETURNS tinyint(1)
begin
declare cur_weekday tinyint default null;
declare checked_date date;
declare modeactive boolean default false;
declare modeenable boolean default false;
declare modestarttime datetime  default null;
declare modestoptime datetime  default null;
declare modetimestype tinyint default null;
declare matched boolean default false;

select Active, Enabled, StartTime, StopTime,TimeStyle into modeactive, modeenable, modestarttime, modestoptime, modetimestype 
            from BroadcastMode where idBroadcastMode = modeid limit 1;
   
  if (modeenable = false) then
     return false;
  end if;   
 
 if (modetimestype = 0) then
     if (PlayDate = date(modestarttime) ) then
         set matched = true;
      end if;
 else
     select AlteredScheduleDay into cur_weekday from AlternateDate where SpecialDate = PlayDate;
      if cur_weekday is null then 
           set cur_weekday = weekday(PlayDate);
       end if;       
       if (modetimestype & (0x01 << cur_weekday)  <> 0 ) then 
        
        set matched = true;
        end if;
   end if;    
    
if (matched = false) then 
    
    if  (modeactive = false) then
        return false;
    end if;
 end if;
 
 if  (modeactive = false)  and (PlayTime < time(modestarttime)) then
     return false;
 end if;    

if (PlayTime <  time(modestoptime)) then
    return true;
end if;    
return false;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_check_session_daytime
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_check_session_daytime`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `func_check_session_daytime`(
          brdmode int,
          weekday tinyint, 
          checked_time datetime,
          last_time datetime,
          cur_time datetime
         ) RETURNS tinyint(1)
begin

declare cur_weekday tinyint default null;
declare checked_date date;
declare activemode boolean default false;


if (last_time >= cur_time) then
    return false;
end if;    

if (brdmode > 0) then
     select Active into activemode from BroadcastMode where idBroadcastMode = brdmode limit 1;
     if  not (activemode = true) then
        return false;
     end if;
end if;     


if  (weekday > 6) then

    if (checked_time  > last_time) and (checked_time <= cur_time) then 
        return true;
    end if;    
else
    
     if (time(last_time) > time(cur_time)) then
         
         if (time(checked_time) > time(last_time) ) then
              set checked_date = date(last_time);
         else 
              if (time(checked_time) <= time(cur_time)) then
                    set checked_date = date(cur_time);
              else
                    return false;
               end if ;    
          end if;
      else
          
          if (time(checked_time) <= time(last_time) )  or 
              (time(checked_time) > time(cur_time))  then
              
              return false;
           end if;   
           
           set checked_date = date(cur_time);
      end if;
      
       
      select AlteredScheduleDay into cur_weekday from AlternateDate where SpecialDate = checked_date;

      if cur_weekday is null then 
           set cur_weekday = weekday(checked_date);
       end if;
     
    if (brdmode > 0) or (weekday = cur_weekday)  then 
        
        return true;
   end if;    
end if;

return false;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_check_task_privilege
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_check_task_privilege`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`localhost` FUNCTION `func_check_task_privilege`(
                 user int, 
                 StreamType tinyint,
                 SysEnabled tinyint, 
                 RfDevCtrl BINARY(16)) RETURNS tinyint(1)
BEGIN
	declare Priv int default null;

    if (user is null or user = 0) then
		return true;
    end if;

	select privilege into Priv from Users where User_ID = user;

	if Priv is null then
		return false;
  end if;

	if ((Priv & 0x01) = 0) and (SysEnabled is not null) then         
		return false;
  end if;

	if ((Priv & 0x100) = 0) and (StreamType <> 0) then
		return false;
  end if;
        
  if ((Priv & 0x10000) = 0)  and (RfDevCtrl is not null) and (RfDevCtrl <> 0x00000000000000000000000000000000) then 
		return false;
  end if;

	return true;
END$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_dulicate_device
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_dulicate_device`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`localhost` FUNCTION `func_dulicate_device`(
    SrcDevice varchar(50),
	DstDevice varchar(50),
    mask tinyint unsigned) RETURNS int(11)
BEGIN
    declare base_cfg varchar(704) default null;
	declare name_cfg varchar(256) default null;
    declare cfg varchar(960) default null;
    declare ret int default null;

    
    if ((mask & 0x01) <> 0) then  
       select SUBSTRING(hex(Dev_configuration), 257, 704) into base_cfg from DeviceList where DevID = SrcDevice; 
     
	   
	   if ((mask & 0x02) <> 0) then
		   select SUBSTRING(hex(Dev_configuration), 1, 256) into name_cfg from DeviceList where DevID = SrcDevice; 
       else
           select SUBSTRING(hex(Dev_configuration), 1, 256) into name_cfg from DeviceList where DevID = DstDevice; 
	   end if;

       if (base_cfg is null) or (name_cfg is null) then
	       return 0;
	   end if;

       set cfg = CONCAT(name_cfg, base_cfg);
       
	   select device_config(a.IpAddress, a.DeviceID, cfg, b.Dev_Name, b.Dev_Description) into ret
			from DeviceStatus a left join DeviceList b on a.DeviceID = b.DevID
            where a.DeviceID = DstDevice;

       if not (ret = 497) then
          return 0;
       end if;
    end if;

    if ((mask & 0x08) <> 0) then
        update DeviceList set Parent = (select Parent from (select * from DeviceList) as tmp_table 
										where DevID = SrcDevice) where DevID = DstDevice;
    end if;

    if ((mask & 0x10) <> 0) then
        delete from UserDevices where DevID = DstDevice;
        insert into UserDevices(UserID, DevID, Pri)
            select UserID, DstDevice, Pri from UserDevices where DevID = SrcDevice and Pri!=0;

        insert into Timetable(UserId, DevId, WeekDay, Start, End)
        select `UserId`,DstDevice,`WeekDay`,`Start`,`End` from Timetable where DevId=SrcDevice;
    end if;

    if ((mask & 0x04) <> 0) then
		delete from SessionDevice where DeviceID = DstDevice;
        insert into SessionDevice(DeviceID, SessionID, KeyIndex, DevDisabled) 
               select DstDevice, SessionID, KeyIndex, DevDisabled from SessionDevice where DeviceID = SrcDevice;
        
		delete from BrdModeMember where DeviceID = DstDevice;
        insert into BrdModeMember(BrdModeID, DeviceID) 
               select BrdModeID, DstDevice from BrdModeMember where DeviceID = SrcDevice;

        delete from DevCtrlSchedule where DevID = DstDevice;
        insert into DevCtrlSchedule(DevID,ActionTime,`Action`,WeekDay,State,ExtArgs,`Disable`)
               select DstDevice,ActionTime,`Action`,WeekDay,State,ExtArgs,`Disable` from DevCtrlSchedule where DevID = SrcDevice; 
               
        insert into Timetable(DevId, UserId, WeekDay, Start, End, Type)
            select DstDevice, UserId, WeekDay, Start, End, Type from Timetable where DevId = SrcDevice;
    end if;

    if ((mask & 0x80) <> 0) then
        delete from UserDevices where DevID = SrcDevice;
        delete from DevCtrlSchedule where DevID = SrcDevice;
        delete from SessionDevice where DeviceID = SrcDevice;
        delete from BrdModeMember where DeviceID = SrcDevice;
        delete from DeviceList where DevID = SrcDevice;
    end if;
    return 1;
END$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_get_dev_mode
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_get_dev_mode`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `func_get_dev_mode`( 
                                    dev_id varchar(50),
                                    checked_daytime datetime) RETURNS int(11)
begin
   declare checkday date;
   declare checktime time;
   declare checkweek int;
   declare ret int default null;
   
   set checkday = date(checked_daytime);
   set checktime = time(checked_daytime);
   
   select AlteredScheduleDay into checkweek from AlternateDate where SpecialDate = checkday;
    if checkweek is null then 
           set checkweek = weekday(checkday);
    end if;       

   
   select  BroadcastMode.idBroadcastMode into ret from BroadcastMode, BrdModeMember 
                  where (BrdModeMember.DeviceID =  dev_id) and
                        (BrdModeMember.BrdModeID = BroadcastMode.idBroadcastMode) and
                        (BroadcastMode.Enabled = true) and
                        (    (  (  (  (BroadcastMode.TimeStyle = 0 and checkday = date(BroadcastMode.StartTime)) or
                                      (BroadcastMode.TimeStyle & (0x01 << checkweek)  <> 0) 
								   ) and  (checktime >= time(BroadcastMode.StartTime))
                                ) or (BroadcastMode.Active = true)
						     ) 
                            and   
                            (   (BroadcastMode.TimeStyle = 0 and checkday <> date(BroadcastMode.StartTime)) or  
							    ( (BroadcastMode.TimeStyle <> 0) and (BroadcastMode.TimeStyle & (0x01 << checkweek)  = 0)) or
                                (checktime < time(BroadcastMode.StopTime))
							)
                        )
      order by BroadcastMode.Priority limit 1;
  
  return ret;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_get_mediafile_Owner
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_get_mediafile_Owner`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `func_get_mediafile_Owner`(mediaID int) RETURNS int(11)
BEGIN
	declare medid int default null;
	declare pid int default null;
	declare own int default null;
	declare foldflag tinyint default null;

	select mediafile.Parent,mediafile.`Owner`,mediafile.Sysfolder,mediafile.MediaID into pid,own,foldflag,medid from MediaFiles mediafile where mediafile.MediaID = mediaID limit 1;
	if(medid is null) then
		set own = -1;
		return own;
	else
		if((foldflag is not null) and (foldflag = 1)) then
			if(own is null) then
				set own = 0;
			end if;
			return own;
		else
			while((pid is not null) and (pid <> 0)) do
				select mediafile.Parent,mediafile.`Owner`,mediafile.Sysfolder into pid,own,foldflag from MediaFiles mediafile where mediafile.MediaID = pid limit 1;
				
				if((foldflag is not null) and (foldflag = 1)) then
					if(own is null) then
						set own = 0;
					end if;
					return own;
				end if;

			end while;

		end if;
		set own = 0;
		return own;
	end if;
	
END$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_ipcall_request
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_ipcall_request`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `func_ipcall_request`(
	devid varchar(50),
	request int) RETURNS int(11)
BEGIN
    declare waiterCnt int default 0;
    declare callCnt int default 0;
    declare ret int default 0;

    select IpCallStatus into @callStatus from DeviceStatus where DeviceID=devid;
	select count(*) into waiterCnt from CallWaiter where addtime(updateAt, 10) > now();
    if (request = 0) or (@callStatus is null) or (@callStatus & 0x80 <> 0x80) then 
        update IpCall set status='idle' where device=devid and status <> 'idle';
        update DeviceDesiredStaus set IpCall=0 where DeviceID=devid and IpCall <> 0;
	elseif(waiterCnt = 0) then
		if(request = 1) then
			update `DeviceDesiredStaus` set `IpCall` = 3 where DeviceID=devid and IpCall = 0;
		end if;
	elseif(callCnt < 8) and (@callStatus & 0x8f = 0x80) then 
		if(request = 1) or (request = 2) then 
			insert into IpCall (device, direction, listen) values (devid, (case request when 1 then 'd2s' else 'b2s' end), 0);
			update `DeviceDesiredStaus` set `IpCall` = 1 where DeviceID=devid;
            set ret = 1;
		elseif(request = 4) then 
			insert into IpCall (device, direction, listen) values (devid, 'b2s', 1);
			update `DeviceDesiredStaus` set `IpCall` = 0 where DeviceID=devid;
            set ret = 1;
		end if;
	end if;
    return ret;
END$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_keepalive_transmit
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_keepalive_transmit`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`localhost` FUNCTION `func_keepalive_transmit`( 
          net_id int, proxy varchar(50),dst_ip varchar(50)
         ) RETURNS varchar(50) CHARSET gb2312
begin
if  (dst_ip is null)  and (proxy = '0.0.0.0') then
    return 0;
end if;    
select Description into @ver from BaseInfo where InfomationID=0x200;
if (net_id = 0)  then     
    return srv_send_keepalive(proxy, 7805, 32, @ver) ;
 else 
    if  (dst_ip is null)  then
        return srv_send_keepalive(proxy, 7805, 40, @ver) ;
     else    
        return srv_send_keepalive(dst_ip, 7805, 40, @ver) ;
     end if;    
end if;

end$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_qrcode_request
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_qrcode_request`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `func_qrcode_request`(
	devid varchar(50),
    opcode varchar(50)) RETURNS varchar(128) CHARSET utf8
BEGIN
	set @uuid = 'unknow';
    select Description into @uuid from BaseInfo where InfomationID=313;
    set @host = 'www.idste.net';
    select Description into @host from BaseInfo where InfomationID=336;
    return concat('https://', @host , '/s/' , opcode, '?u=', @uuid , '&i=' , devid);
END$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_set_device_sysenable
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_set_device_sysenable`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `func_set_device_sysenable`(
    devid varchar(50),
    sys_enable tinyint(4)) RETURNS tinyint(4)
BEGIN
    if(sys_enable = 0) or (sys_enable = 1) then
        update DeviceStatus set SysPowerCmd = sys_enable where DeviceID=devid;
        return 1;
    else
        return 0;
    end if;
END$$

DELIMITER ;

-- -----------------------------------------------------
-- function func_update_rf_ctrl
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`func_update_rf_ctrl`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `func_update_rf_ctrl`(
        dev_id varchar(50),
        old_state binary(16),
        new_state binary(16)
    ) RETURNS binary(16)
BEGIN
    set @ip = NULL;
    select IpAddress into @ip from DeviceStatus where DeviceID=dev_id;
    select update_rf_ctrl(dev_id, @ip, old_state, new_state) into @ret;
    return @ret;
END$$

DELIMITER ;

-- -----------------------------------------------------
-- function get_dev_mode
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`get_dev_mode`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `get_dev_mode`(dev_id varchar(50)) RETURNS int(11)
begin
 declare ret int default 0;
 
 select BrdModeMember.BrdModeID into ret from BrdModeMember
                left join BroadcastMode on BroadcastMode.idBroadcastMode = BrdModeMember.BrdModeID
                where (BrdModeMember.DeviceID = dev_id) and (BroadcastMode.Active = true) 
                 order by    BroadcastMode. Priority LIMIT 1;       
                 
 return ret;                
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function get_dev_session
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`get_dev_session`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `get_dev_session`(dev_id varchar(50), sessionId smallint unsigned, 
                                                                                       playerid varchar(50), SesMode int) RETURNS tinyint(1)
begin
 declare modeid int default 0;
 declare sespriority int default null;
 declare modepriority int default null;
 declare modemembertype boolean default false;
 
 set modeid = get_dev_mode(dev_id) ;
 
 select Priority into modepriority from BroadcastMode where idBroadcastMode = modeid LIMIT 0, 1;
 select Priority , MemberMode into sespriority, modemembertype from
                               PlaySessions where PlaySessions.SessionID = sessionId LIMIT 0, 1;
 
  
 if (modeid = SesMode and  modemembertype = true) then
 
     return true;
  end if;
  
 if not (modeid > 0 and  SesMode <> modeid and sespriority >= modepriority) then
    if exists (select DeviceID from SessionDevice 
                 where (SessionDevice.DeviceID = dev_id) and (SessionDevice.SessionID = sessionId) and (not DevDisabled = 1)) then
                 
                 return true;
      else
                return exists (select DeviceList .DevID from DeviceList , PlayerKeys 
                            where DeviceList .DevID =  dev_id and PlayerKeys.PlayerID = playerid and
                            PlayerKeys.GroupDisable = 0 and 
                            ((PlayerKeys.GroupID <> 0) and sp_dev_belong_group(DeviceList.DevID, PlayerKeys.GroupID)));

    end if;  
 end if;

  
  return false;                                
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function get_idle_port
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`get_idle_port`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `get_idle_port`() RETURNS int(10) unsigned
begin

declare idle_port int unsigned;

set idle_port = 7000;

emp_loop: loop   
if not exists(select * from PlayerStatus where PlayPort = idle_port) then   
leave emp_loop;
end if;
set idle_port = idle_port + 2;
end loop;

return  idle_port;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function get_idle_sessionid
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`get_idle_sessionid`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `get_idle_sessionid`(video boolean) RETURNS smallint(5) unsigned
begin

declare ses_id smallint unsigned default 1;

 emp_loop: loop   
if not exists(select SessionID from PlaySessions where SessionID = ses_id) then   
leave emp_loop;
end if;
set ses_id = ses_id + 1;
end loop;

return  ses_id;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function get_network
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`get_network`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `get_network`(ipaddr varchar(50)) RETURNS int(10) unsigned
BEGIN

declare src_ip int unsigned;
declare mask int unsigned;
declare proxy int unsigned;
declare netid int unsigned;
declare ret int default 0;

DECLARE done INT DEFAULT 0;   
DECLARE cur1 CURSOR FOR SELECT 
    idSubNetwork, inet_aton(NetMask), inet_aton(IpAddress) 
    FROM SubNetwork;   
DECLARE CONTINUE HANDLER FOR NOT FOUND SET done=1;   

set src_ip = inet_aton(ipaddr);
OPEN cur1;   

emp_loop: LOOP   

FETCH cur1 INTO netid, mask, proxy;   

if ((src_ip & mask) = (proxy & mask))  and (mask <> 0) then
set ret = netid;
set done = 1;


end if;

IF done=1 THEN   
LEAVE emp_loop;   
END IF;   
END LOOP emp_loop;   
CLOSE cur1;   

return  ret;
END$$

DELIMITER ;

-- -----------------------------------------------------
-- function get_rtmp_url
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`get_rtmp_url`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `get_rtmp_url`(dev_id varchar(50)) RETURNS varchar(256) CHARSET utf8
BEGIN
	declare srsSrv varchar(128) default null;
    declare a int default 0;
    declare b varchar(128) default null;
    declare flag boolean default true;
	declare cur_tmp CURSOR FOR select `id`,`server` from `SrsServer` order by id asc;
	declare continue handler for NOT FOUND set flag=false;
	
	OPEN cur_tmp;
	fetchLoop:loop
		fetch cur_tmp into a,b;
		if(flag=false) then
			leave fetchLoop;
		end if;
        insert into SrsServerStatus values(a, b, 0) 
			on duplicate key update 
				id=values(id), `server`=values(`server`);
	end loop;
	close cur_tmp;

    select `server` into srsSrv from SrsServerStatus order by count asc limit 1;
    if(srsSrv is null) then
		insert into SrsServer (`name`, `server`) values('localhost', inet_ntoa(get_srv_ip())) 
			on duplicate key update `server`=values(`server`);
        set srsSrv = inet_ntoa(get_srv_ip());
    end if;
    update MediaFiles, PlayListFiles, PlaySessions 
        set MediaFiles.FilePath=concat(concat(concat('rtmp://', srsSrv), '/bw803/') , dev_id) 
        where PlayListFiles.FileID=MediaFiles.MediaID
            and PlayListFiles.SessionID = PlaySessions.SessionID
            and PlaySessions.PlayerID=dev_id;
    return concat(concat(concat('rtmp://', srsSrv), '/bw803/') , dev_id);
END$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_add_media_blcok
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_add_media_blcok`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_add_media_blcok`(in media_id int,
        in dat varbinary(8192),
        out ret int)
BEGIN
         set ret = add_media_block(CONCAT(@@datadir, 'media/', media_id) , dat);                      
END$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_check_group
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_check_group`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `sp_check_group`(
           check_group int,
           ses smallint unsigned,
           keyno int,
           checkstate bool,
           depth int)
begin
    declare gid int;
    declare cur1 cursor for select ClassID from DevClasses where Parent = check_group;
    declare continue handler for sqlstate '02000' set gid = null; 


      if (depth < 5) then
            if  (checkstate = true) then
                 insert into SessionDevice(DeviceID, SessionID, KeyIndex)
                       select `DeviceList`.`DevID`, ses, keyno from DeviceList where parent = check_group
                on duplicate key update SessionID = values(SessionID);                
            else
                 delete SessionDevice from SessionDevice , DeviceList 
                       where SessionDevice.SessionID = ses and SessionDevice.KeyIndex = keyno 
                                     and SessionDevice.DeviceID = DeviceList.DevID and
                                      DeviceList.parent = check_group;
            end if;  

       open cur1; 
       fetch cur1 into gid; 

       while ( gid is not null )  do
         call sp_check_group(gid, ses, keyno, checkstate, depth+1); 
         fetch cur1 into gid; 
       end while; 
 end if; 
end$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_copy_mode
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_copy_mode`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_copy_mode`(
    old_modeid int,
    new_enabled boolean
    )
begin
declare new_modeid int default null;

declare old_session smallint default null;
declare new_session smallint default null;

declare mode_task_cur cursor for select  SessionID  from PlaySessions where BrdMode = old_modeid;  
declare continue handler for sqlstate '02000' set old_session = null;

  
  insert into BroadcastMode(ModeName, Priority, Enabled, StartTime, StopTime, TimeStyle, Active)  
           (select concat(ModeName, " copy"), Priority, new_enabled, StartTime, StopTime, TimeStyle, false from BroadcastMode where idBroadcastMode=old_modeid) ;
   
   set new_modeid = last_insert_id();
   
   if (new_modeid is not null) then
      
      insert into BrdModeMember(BrdModeID,DeviceID)  (select new_modeid,DeviceID from BrdModeMember where BrdModeID =  old_modeid);
      
      
      open  mode_task_cur;  
       fetch mode_task_cur into old_session;  
         
      while ( old_session is not null) do
            set new_session = get_idle_sessionid(false);
             insert into PlaySessions(SessionID,SessionName,SessionType,Priority,`Status`,CircleLength,ClassID,PlayerID,Parent,BrdMode,
                                                                MemberMode,StreamType,SysEnabled,RfDevCtrl,PlayMode, AudioGain)
                                   (select new_session,SessionName,SessionType,Priority,`Status`,CircleLength,ClassID,PlayerID,Parent,new_modeid,
                                                                MemberMode,StreamType,SysEnabled,RfDevCtrl,PlayMode,AudioGain
                                                                from PlaySessions where SessionID = old_session);
            
            insert into PlaySessionTime(SessionID,WeekDay,PlayTime,TempFlag) 
                          (select new_session,WeekDay,PlayTime,TempFlag from PlaySessionTime where SessionID = old_session);
            
            insert into PlayListFiles(FileID,SequenceID,SessionID,Duration,KeyIndex,PlayerID) 
                          (select FileID,SequenceID,new_session,Duration,KeyIndex,PlayerID from PlayListFiles where SessionID = old_session);
                          
             insert into SessionDevice(DeviceID,SessionID,KeyIndex,DevDisabled)
                           (select  DeviceID,new_session,KeyIndex,DevDisabled from  SessionDevice where SessionID = old_session);
             
             fetch mode_task_cur into old_session;  

      end while;
      close mode_task_cur;
   end if;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_copy_template
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_copy_template`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_copy_template`(
    old_template int
    )
begin
declare new_template int default null;

declare old_session smallint default null;
declare new_session smallint default null;

declare task_cur cursor for select  SessionID  from PlaySessions 
        where (Template = old_template) and ((BrdMode is null) or (BrdMode = 0)) and ((SessionType = 0) or (SessionType = 8));   
declare continue handler for sqlstate '02000' set old_session = null;

  
  insert into TaskTemplate(TemplateName, Enabled)  
           (select concat(TemplateName, " copy"), 0 from TaskTemplate where idTaskTemplate = old_template) ;
   
   set new_template = last_insert_id();
   
   if (new_template is not null) then

      open  task_cur;  
      fetch task_cur into old_session;  
         
      while ( old_session is not null) do
            set new_session = get_idle_sessionid(false);
             insert into PlaySessions(SessionID,SessionName,SessionType,Priority,`Status`,CircleLength,ClassID,PlayerID,Parent,BrdMode,
                                      MemberMode,StreamType,SysEnabled,RfDevCtrl, `Owner`, PlayMode, AudioGain, Template)
                                   (select new_session,SessionName,SessionType,Priority,`Status`,CircleLength,ClassID,PlayerID,Parent,BrdMode,
                                           MemberMode,StreamType,SysEnabled, RfDevCtrl, `Owner`, PlayMode, AudioGain, new_template
                                           from PlaySessions where SessionID = old_session);
            
            insert into PlaySessionTime(SessionID,WeekDay,PlayTime,TempFlag) 
                          (select new_session,WeekDay,PlayTime,TempFlag from PlaySessionTime where SessionID = old_session);
            
            insert into PlayListFiles(FileID,SequenceID,SessionID,Duration,KeyIndex,PlayerID) 
                          (select FileID,SequenceID,new_session,Duration,KeyIndex,PlayerID from PlayListFiles where SessionID = old_session);
                          
             insert into SessionDevice(DeviceID,SessionID,KeyIndex,DevDisabled)
                           (select  DeviceID,new_session,KeyIndex,DevDisabled from  SessionDevice where SessionID = old_session);
             
             fetch task_cur into old_session;  

      end while;
      close task_cur;
   end if;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_del_media_class
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_del_media_class`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_del_media_class`(classid int)
BEGIN
      UPDATE MediaFiles SET ClassID=0 WHERE (Parent=classid) ;
	DELETE FROM MediaClasses WHERE ID = classid;
END$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_del_media_file
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_del_media_file`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_del_media_file`(userid int, media_id int)
BEGIN

	declare tmp_own int default null;
	declare tmp_priority int;
	declare tmp_mediaid int default null;
	declare mediacurs cursor for select MediaID from MediaFiles where Parent = media_id;
	declare continue handler for not found,1329,sqlstate '02000' set tmp_mediaid = null;

	select func_get_mediafile_Owner(media_id) into tmp_own;
	

	if((tmp_own = userid) or (userid = 0)) then

		open mediacurs;
		fetch mediacurs into tmp_mediaid;
			
		while(tmp_mediaid is not null) do
			call sp_del_media_file(userid,tmp_mediaid);
			fetch mediacurs into tmp_mediaid;
		end while;
		
		
		if ( not exists (select PlayingFileID from  PlayingSessions where PlayingFileID = media_id)) then
			DELETE FROM PlayListFiles WHERE FileID = media_id;
			DELETE FROM MediaFiles WHERE MediaID = media_id; 
		end if;

	end if;

END$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_del_session_class
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_del_session_class`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_del_session_class`(classid int)
BEGIN
	UPDATE PlaySessions SET ClassID=NULL WHERE ClassID = classid;
	DELETE FROM SessionClasses WHERE (ClassID=classid);
END$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_delete_device
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_delete_device`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_delete_device`(dev_id varchar(50))
begin

delete from UserDevices where DevID = dev_id;
delete from DevCtrlSchedule where DevID = dev_id;
delete from SessionDevice where DeviceID = dev_id;
delete from BrdModeMember where DeviceID = dev_id;
delete from DeviceList where DevID = dev_id;


delete from PlaySessions where PlayerID = dev_id;
delete from PlayerKeys where PlayerID = dev_id;
delete from Players where PlayerID = dev_id;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_delete_group
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_delete_group`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_delete_group`(GrpID int)
begin
delete from PlayGroupDevices where GroupID = GrpID;
delete from PlaySessionGroups where GroupID = GrpID;
delete from PlayGroups where GroupID = GrpID;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function sp_dev_belong_group
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`sp_dev_belong_group`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `sp_dev_belong_group`(dev varchar(50), groupid int) RETURNS tinyint(1)
begin
    declare ret boolean default false ;
    declare gid int default 0;
   
   set gid  = groupid;
   
      if (groupid is null) or (groupid = 0) then
       return true;
    end if;
    
    if (dev is null)  then
       return false;
    end if;
    
   select Parent into gid  from  DeviceList   where DevID = dev;
   
   if (gid = groupid) then
       return true;
    end if;
    
    while (( gid is not null ) and (gid <> 0))  do
         select Parent into gid from  DevClasses   where ClassID = gid;
 
         if (gid = groupid) then
               return true;
          end if; 
    end while;        
   return false;   
end$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_dev_keepalive
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_dev_keepalive`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_dev_keepalive`(
    devid varchar(50),
    dev_name varbinary(32),
    dev_status  tinyint,
    power tinyint,
    fault tinyint,
    proj  tinyint,
    autual_ses smallint unsigned,
    rf_dev_status binary(16),
    ip_addr varchar(50),
    ip_call tinyint unsigned,
    auth_key varchar(50)
)
BEGIN
    declare tmp int;
    declare ipCall int;
    INSERT INTO DeviceList(DevID,Dev_Name) VALUES (devid, dev_name)
        ON DUPLICATE KEY UPDATE Dev_Name= VALUES(Dev_Name);
    
    set tmp = get_network(ip_addr);
        
    if(length(trim(auth_key)) = 0) then
        set @uid = NULL;
    else
        set @card = LPAD(trim(auth_key), 10, 0);
        set @cardHex = LPAD(conv(auth_key,10, 16), 8, 0);
        set @cardHex = concat(substring(@cardHex, 7,2), substring(@cardHex, 5, 2), substring(@cardHex, 3, 2), substring(@cardHex, 1, 2));
        set @cardSwitch = LPAD(ltrim(conv(@cardHex, 16, 10)), 10, 0);
        select User_ID into @uid from Users where LPAD(trim(Users.IcCard), 10, 0) = @card or LPAD(trim(Users.IcCard), 10, 0) = @cardSwitch;
    end if;
    INSERT INTO DeviceStatus(DeviceID,  DeviceStatus,State_SysPower,
                             State_FaultStatus, State_ProjectorStatus, ActualSessionID,
                             RfDevStatus, IpAddress, NetworkID, State_Pc,IpCallStatus,User_ID)
          VALUES (devid, dev_status, (power & 0x0F), fault, proj, autual_ses, rf_dev_status, ip_addr, tmp, (power >> 6), ip_call, @uid)
          ON DUPLICATE KEY UPDATE
          DeviceStatus= VALUES(DeviceStatus), State_SysPower = VALUES(State_SysPower),
          State_FaultStatus= VALUES(State_FaultStatus),
          State_ProjectorStatus = VALUES(State_ProjectorStatus),
          ActualSessionID = VALUES(ActualSessionID),
          RfDevStatus =  VALUES(RfDevStatus),
          IpAddress = VALUES(IpAddress),
          NetworkID = VALUES(NetworkID),
          State_Pc = VALUES(State_Pc),
          IpCallStatus = VALUES(IpCallStatus),
          User_ID=VALUES(User_ID);
  
END$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_fetch_playing_file
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_fetch_playing_file`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `sp_fetch_playing_file`(
    sesid smallint,
    file_seq int,
    remained_time int)
begin
	declare random tinyint default 0;
	declare maxid int default 0;

    select PlayMode into random from PlaySessions where  SessionID = sesid;

	if (random > 0) then
		if (remained_time <> 0) then            
           select max(b.SequenceID) into maxid from PlayListFiles b
				   left join MediaFiles c on b.FileID = c.MediaID 
					where b.SessionID = sesid and c.TotalTime > 0;
		   set maxid = round( rand() * maxid);
		   select b.FileID, b.Duration,b.SequenceID, c.Gain, c.FilePath, @@datadir, c.FileName    
                   from PlayListFiles b left join MediaFiles c on b.FileID = c.MediaID 
		               where  (b.SessionID = sesid) and (b.SequenceID >= maxid) and (c.TotalTime > 0)
                   order by SequenceID limit 0, 1;
		else
			if (file_seq = 0) then
			    select max(SequenceID) into maxid from PlayListFiles where SessionID = sesid;
			    set maxid = round( rand() * maxid);
			    select b.FileID, b.Duration,1, c.Gain, c.FilePath, @@datadir, c.FileName    
                   from PlayListFiles b left join MediaFiles c on b.FileID = c.MediaID 
		           where  (b.SessionID = sesid) and (b.SequenceID >= maxid) order by SequenceID limit 0, 1;
			else
                select null; 
            end if;
		  end if;
    else 
        select b.FileID, b.Duration,b.SequenceID, c.Gain, c.FilePath, @@datadir , c.FileName   
               from PlayListFiles b left join MediaFiles c on b.FileID = c.MediaID 
		       where  (b.SessionID = sesid) and (b.SequenceID >= file_seq) order by SequenceID limit 0, 1;
    end if;
	 
    

END$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_get_dev_scheduled_tasks
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_get_dev_scheduled_tasks`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_get_dev_scheduled_tasks`(dev_id varchar(50),
        start_datetime datetime,
        stop_datetime datetime)
label_pro: begin
         declare check_day date;
         declare check_start time;
         declare check_stop time;
         declare check_week int;

         set check_day = date(start_datetime);
         set check_start = time(start_datetime);
         set check_stop = time(stop_datetime);
         
         select AlteredScheduleDay into check_week from AlternateDate where SpecialDate = check_day;
         if check_week is null then 
              set check_week = weekday(check_day);
         end if;    
         
		 select InfoValue into @templateNow from BaseInfo where InfomationID = 0x101;         
         
         if (check_day <> date(stop_datetime)) or (check_start >= check_stop) then
             leave label_pro;
         end if;  
        
		select PlaySessionTime.ScheduleID as ScheduleID, PlaySessionTime.TempFlag as TempFlag, time(PlaySessionTime.PlayTime) as PlayTime, 
                PlaySessions.SessionID as SessionID,PlaySessions.SessionName as SessionName, 
                devmode.idBroadcastMode as DeviceMode, devmode.ModeName as DeviceModeName,
				taskmode.idBroadcastMode as TaskMode, 
				case when (taskmode.idBroadcastMode is not null) then taskmode.Priority else PlaySessions.Priority end as TaskPriority, 
                devmode.Priority as DevPriority
            FROM nccs.PlaySessions 
                left join PlaySessionTime on PlaySessionTime.SessionID =  PlaySessions.SessionID
                left join BroadcastMode devmode on devmode.idBroadcastMode = func_get_dev_mode(dev_id,  DATE_ADD(check_day, INTERVAL time(PlayTime) HOUR_SECOND ))
				left join BroadcastMode taskmode on taskmode.idBroadcastMode = PlaySessions.BrdMode
                left join SessionDevice on SessionDevice.DeviceID = dev_id and SessionDevice.SessionID = PlaySessions.SessionID
                left join BrdModeMember on BrdModeID = PlaySessions.BrdMode and BrdModeMember.DeviceID = dev_id
			where (    (check_start <= time(PlaySessionTime.PlayTime) and check_stop > time(PlaySessionTime.PlayTime)) and 
					   (    (    ((taskmode.idBroadcastMode is null) or (taskmode.idBroadcastMode = 0)) and 
                                 (check_week = PlaySessionTime.WeekDay) and
                                 ((PlaySessions.Priority < devmode.Priority) or (devmode.Priority is null))
                            ) or 
							(taskmode.idBroadcastMode = devmode.idBroadcastMode) or 
                            (   ((devmode.Priority is null) or (devmode.Priority > taskmode.Priority) ) and  
								(taskmode.Enabled = true) and
							    
								(
                                    (  (  (  (taskmode.TimeStyle = 0 and check_day = date(taskmode.StartTime)) or
                                             (taskmode.TimeStyle & (0x01 << check_week)  <> 0) 
								          ) and  (time(PlaySessionTime.PlayTime) >= time(taskmode.StartTime))
                                       ) or (taskmode.Active = true)
						            ) 
                                    and   
                                    (   (taskmode.TimeStyle = 0 and check_day <> date(taskmode.StartTime)) or  
							            ( (taskmode.TimeStyle <> 0) and (taskmode.TimeStyle & (0x01 << check_week)  = 0)) or
                                        (time(PlaySessionTime.PlayTime) < time(taskmode.StopTime))
							        )
								)
                            )
						) and 
						(
							( ((PlaySessions.MemberMode is null) or (PlaySessions.MemberMode = 0)) and (SessionDevice.SessionDevID is not null) ) or
							( (PlaySessions.MemberMode > 0) and (BrdModeMember.DevIDMode is not null))
						) 
					and ((PlaySessions.Template is null) or (PlaySessions.Template=@templateNow))
				  )
			 order by PlayTime;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function sp_group_dev_ctrl_func
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`sp_group_dev_ctrl_func`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `sp_group_dev_ctrl_func`(
    ctrl_devid varchar(50),
    ctrl_groupid int,
    cmd int,
    state int,
    extargs varchar(256)) RETURNS int(11)
begin
    declare tmp int default 0 ;
    
    if (ctrl_devid is not null) and (ctrl_devid <>"") then
        select sp_send_dev_ctrl_function(ctrl_devid, IpAddress, cmd,state, 0, 0, extargs )  into tmp from DeviceStatus 
        where DeviceID = ctrl_devid;
     end if;
     
     if (ctrl_groupid is not null) and (ctrl_groupid <> 0) then
         
         
         insert into tmp_result
           select sp_send_dev_ctrl_function(DeviceStatus.DeviceID, DeviceStatus.IpAddress, cmd,state, 0, 0, extargs ) 
               from DeviceStatus , DeviceList
               where  DeviceList.DisableParentSchedule = false and
                              sp_dev_belong_group(DeviceList.DevID, ctrl_groupid) and 
                              DeviceList.DevID = DeviceStatus.DeviceID ;
                              
          delete from tmp_result;                    

     end if;

    return tmp;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- Event `event_timer`
-- -----------------------------------------------------
USE `nccs`;
DROP EVENT IF EXISTS nccs.`event_timer`;
DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` EVENT `event_timer`
ON SCHEDULE EVERY 1 SECOND ON COMPLETION PRESERVE
ENABLE DO
BEGIN
    set @timenow = unix_timestamp();
    call sp_timer_deamon();
    if(@timenow % 5 = 0) then
        call sp_keepalive_send();
    end if;
    if(@timenow % 2 = 0) then
        call sp_ipcall_check();
    end if;
END
$$
DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_ipcall_check
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_ipcall_check`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_ipcall_check`()
BEGIN
    delete from IpCall where IpCall.status='idle'
        and (webrtcUpdate is null or addtime(IpCall.webrtcUpdate,  '00:00:10') < now()
             or IpCall.webrtcUpdate > now());

	update IpCall,CallWaiter set IpCall.`status`='idle'
		where IpCall.`status` <> 'idle'
			and ((addtime(CallWaiter.`updateAt`, 10) < now() 
					and IpCall.waiter = CallWaiter.id)
				or (addtime(IpCall.webrtcUpdate, 10) < now()) 
				or (addtime(IpCall.ringing, 30) < now()
					and IpCall.webrtcStatus <> 'running')); 
	update DeviceDesiredStaus set IpCall = 0 where IpCall = 3 and addtime(IpCallEvent, 3) < now();
END$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_keepalive_send
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_keepalive_send`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_keepalive_send`()
begin
 
 
  select func_keepalive_transmit(c.idSubNetwork, c.IpAddress, c.proxy) from 
( select b.idSubNetwork, b.IpAddress, a.IpAddress as proxy from SubNetwork as b 
    left join (select NetworkID, IpAddress from DeviceStatus group by  NetworkID) as a on b.idSubNetwork = a. NetworkID) as c;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_player_keepalive
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_player_keepalive`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_player_keepalive`(
    devid varchar(50),
    player_type tinyint,   
    player_status tinyint, 
    actual_ses int , 
    keymap int,           
    key_type tinyint,  
    ip_addr varchar(50)
    )
BEGIN
    declare net_id int;
    declare key_index int;
    declare group_en tinyint;
    declare dev_en tinyint;
    
if ((player_type <> 2) or exists(select PlayerID from Players where PlayerID = devid)) then
   

    insert into Players(PlayerID, PlayerType ) values (devid, player_type)
        on duplicate key update PlayerType= values(PlayerType);
    
    set net_id = get_network(ip_addr);

    if(not exists(select PlayerID from PlayerStatus where PlayerID = devid)) then
        insert into PlayerStatus(PlayerID, SessionID, ActualSesID, IpAddress, NetID, PlayType)
            values (devid, actual_ses, actual_ses, ip_addr, net_id, player_type);
    end if;
    
    update   PlayerStatus set PlayPort = get_idle_port() where PlayPort is null and PlayerID = devid;


    if ((player_type <> 0) and (player_type <> 8)) then
        set @sesid = 0;
        if (player_status <> 0) then
            select SessionID into @sesid from PlaySessions where PlayerID = devid limit 1;
        end if;
        if (player_status = 1) then
            update PlayerStatus set SessionID = @sesid, ScheduleID=null, IpAddress=ip_addr, ActualSesID=actual_ses, NetID = net_id where PlayerID = devid;
        else
            update PlayerStatus set SessionID = @sesid,IpAddress=ip_addr, ActualSesID=actual_ses, NetID = net_id where PlayerID = devid;
        end if;

         
        insert into PlayerAlive(PlayerID, ReFreshTime) values(devid, now()) 
            on duplicate key update ReFreshTime=values(ReFreshTime);
    else
        update PlayerStatus set ActualSesID=actual_ses, IpAddress=ip_addr, NetID=net_id where PlayerID = devid;
    end if;

    if (player_type = 1) then

        
        set  key_index = 0;
        while (key_index < 16) do
            if (keymap & (0x01 << key_index) <> 0) then
                if (key_type = 0) then
                    set group_en = 0;
                    set dev_en = 1;
                else
                    set dev_en = 0;
                    set group_en = 1;
                end if;    
            else
                set dev_en = 1;
                set group_en = 1;
            end if;
 
    
            insert into PlayerKeys(PlayerID, `Index`, GroupDisable, DevDisable)  values (devid, key_index + 1, group_en, dev_en)
                on duplicate key update GroupDisable=values(GroupDisable), DevDisable=values(DevDisable) ;
 
		    set  key_index =key_index + 1;

        end while;

    end if;
end if; 
end$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_reset_player
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_reset_player`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_reset_player`(player varchar(50))
BEGIN
update PlayerStatus set SessionID = 0, ActualSesID = 0 where PlayerID = player ;
END$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_send_dev_cfg_cmd
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_send_dev_cfg_cmd`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_send_dev_cfg_cmd`(
    devid VARCHAR(50),
    Ipaddr VARCHAR(50),
    devcfg VARCHAR(16384),
    devname VARCHAR(32),
    devlocation VARCHAR(96)
    )
BEGIN
    declare tmp int;
    if(devname is null) then
		set devname = '';
	end if;
    if(devlocation is null) then
		set devlocation = '';
	end if;
    set tmp = device_config(Ipaddr, devid, devcfg, devname, devlocation);
END$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_send_dev_ctrl_cmd
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_send_dev_ctrl_cmd`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_send_dev_ctrl_cmd`(
    devid varchar(50),
    Ipaddr varchar(50),
    cmd tinyint unsigned,
    para1 int unsigned,
    para2 int unsigned,
    para3 int unsigned,
    extarg varchar(256)
    )
begin
    declare ret int default null;
    if(cmd = 62) then
        update DeviceDesiredStaus set SysEnabled =
                func_set_device_sysenable(devid, para1)
            where DeviceID = devid;
    elseif(extarg is null) then
        set ret = device_ctrl(Ipaddr, devid, cmd, para1, para2, para3);
    else
        set ret = device_ctrl(Ipaddr, devid, cmd, para1, para2, para3, extarg);
    end if;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function sp_send_dev_ctrl_function
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`sp_send_dev_ctrl_function`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `sp_send_dev_ctrl_function`(
    user_id int,
    devid varchar(50),
    Ipaddr varchar(50),
    cmd int ,
    para1 int ,
    para2 int ,
    para3 int ,
    extarg varchar(256)
    ) RETURNS int(11)
BEGIN

    declare ret int default null;  
    
    if(cmd = 0x40) then
        set ret = device_message(Ipaddr, devid,  para1, extarg);
    else
        set ret = device_ctrl(Ipaddr, devid, cmd, para1, para2, para3);
    end if;
     
    return ret;
END$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_send_group_cmd
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_send_group_cmd`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_send_group_cmd`(
    groupid int,
    cmd int,
    state int,
    extargs varchar(256))
begin

       insert into tmp_result 
              select sp_send_dev_ctrl_function(null,DeviceID, IpAddress, cmd,state, 0, 0, extargs) from DeviceStatus
               where IpAddress is not null  and sp_dev_belong_group(DeviceID,  groupid) = true;
               
        delete from   tmp_result  ;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_session_clean_up
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_session_clean_up`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_session_clean_up`()
begin
 
 delete PlaySessions from PlaySessions 
where (SessionType = 0 or SessionType = 8) and 
               (not exists (select ScheduleID from PlaySessionTime where SessionID = PlaySessions.SessionID)) and
               (not exists (select PlayerID from PlayingSessions where SessionID = PlaySessions.SessionID) );

end$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_session_ctrl
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_session_ctrl`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_session_ctrl`(ses_id  smallint unsigned, ses_status int, sche_id int)
begin
declare Player int default null;
declare ses_type tinyint unsigned default 0;


if (ses_status = 1) then
     
     if exists(select Player = PlayerID from PlayerStatus where SessionID = ses_id) then
            
            update PlayingSessions set  Pause = 0 where SessionID = ses_id;
     else
            set @playerid = null;
            select SessionType,PlayerID,SessionName into ses_type,@playerid,@sessionName from PlaySessions where SessionID = ses_id limit 1;

            if ((ses_type < 8)  and (ses_type <> 1)) then
                
                update PlayerStatus set SessionID = ses_id, ScheduleID = sche_id
                            where (SessionID = 0 OR SessionID is null)  and 
                                           (ActualSesID = 0 OR ActualSesID is null)   and PlayType = 0 limit 1;
              elseif(ses_type <> 10) then
				  update PlayerStatus set SessionID = ses_id, ScheduleID = sche_id
					where (SessionID = 0 OR SessionID is null)  and
								   (ActualSesID = 0 OR ActualSesID is null)   and PlayType = 8 limit 1;
            elseif(@playerid is not null) then
                update PlayerStatus set ScheduleID=sche_id where PlayerID=@playerid;
                set @ip = null;
                select IpAddress into @ip from PlayerStatus where PlayerID=@playerid limit 1;
                if(@ip is not null) then
                    call sp_send_dev_ctrl_cmd(@playerid, @ip, 131, ses_id, 8064, 0, @sessionName);
                end if;
             end if;
      end if;
else
      if (ses_status = 0) then
            if(sche_id is null) or (sche_id = 0) then
                update PlayerStatus set SessionID = 0 where (SessionID = ses_id) limit 1;
            else
                update PlayerStatus set SessionID = 0 where (SessionID = ses_id) and (ScheduleID = sche_id) limit 1;
            end if;
       else
            update PlayingSessions set  Pause = 1 where SessionID = ses_id;
        end if;   
end if;
end$$

DELIMITER ;

-- -----------------------------------------------------
-- function sp_session_start
-- -----------------------------------------------------

USE `nccs`;
DROP function IF EXISTS `nccs`.`sp_session_start`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` FUNCTION `sp_session_start`(
                                   ses_id int, 
                                   sche_id int,
                                   flag tinyint,
                                   stream tinyint,
                                   brd_mode int,
                                   mode_member boolean,
                                   sys_enable tinyint ,
                                   rf_dev_ctrl_cmd binary(16)) RETURNS tinyint(4)
begin
     declare run_priority int default  null;
     if (flag = 2) then 
         return 0;
     end if;
     
    if ((stream & 0x7f) > 0) then
         call sp_session_ctrl(ses_id, 1, sche_id);
     end if;
     
     if  (brd_mode > 0) then
         if  (mode_member = true)  then
                update DeviceDesiredStaus set SysEnabled = 
                    case when sys_enable is not null then
                        func_set_device_sysenable(DeviceDesiredStaus.DeviceID, sys_enable)
                    else DeviceDesiredStaus.SysEnabled 
                    end, DeviceDesiredStaus.RfDevCtrl =     
                    case when rf_dev_ctrl_cmd is not null then
						func_update_rf_ctrl(DeviceDesiredStaus.DeviceID, DeviceDesiredStaus.RfDevCtrl, rf_dev_ctrl_cmd)
					else
						DeviceDesiredStaus.RfDevCtrl 
					end
                    where   DeviceDesiredStaus.BrdMode = brd_mode;
            else
                    select  Priority into run_priority from BroadcastMode where idBroadcastMode =  brd_mode limit 1;
                    
                    update DeviceDesiredStaus, SessionDevice set DeviceDesiredStaus.SysEnabled = 
                            case when sys_enable is not null then
                                func_set_device_sysenable(DeviceDesiredStaus.DeviceID, sys_enable)
                            else DeviceDesiredStaus.SysEnabled 
                            end, DeviceDesiredStaus.RfDevCtrl =    
                            case when rf_dev_ctrl_cmd is not null then
                                func_update_rf_ctrl(DeviceDesiredStaus.DeviceID, DeviceDesiredStaus.RfDevCtrl, rf_dev_ctrl_cmd)
                            else
                                DeviceDesiredStaus.RfDevCtrl 
                            end
                    where   (SessionDevice.SessionID = ses_id) and (SessionDevice.DevDisabled = false) and 
                            (DeviceDesiredStaus.DeviceID =    SessionDevice.DeviceID) and
                            ((DeviceDesiredStaus.ModePriority is null) or (DeviceDesiredStaus.ModePriority >= run_priority));    
                    
            end if;
     else 
          
          select  Priority into run_priority from PlaySessions where SessionID =  ses_id limit 1;
          
                update DeviceDesiredStaus, SessionDevice set DeviceDesiredStaus.SysEnabled = 
                    case when sys_enable is not null then
                        func_set_device_sysenable(DeviceDesiredStaus.DeviceID, sys_enable)
                    else DeviceDesiredStaus.SysEnabled 
                    end, DeviceDesiredStaus.RfDevCtrl =    
                    case when rf_dev_ctrl_cmd is not null then
						func_update_rf_ctrl(DeviceDesiredStaus.DeviceID, DeviceDesiredStaus.RfDevCtrl, rf_dev_ctrl_cmd)
					else
						DeviceDesiredStaus.RfDevCtrl 
					end
                where   (SessionDevice.SessionID = ses_id) and (SessionDevice.DevDisabled = false) and
                        (DeviceDesiredStaus.DeviceID =    SessionDevice.DeviceID) and
                        ((DeviceDesiredStaus.ModePriority is null) or (DeviceDesiredStaus.ModePriority > run_priority));    
          
          
      end if; 
	
	if ((stream & 0x7f) = 0) and (flag = 1) then
		return 127; 
	end if;
	
    return flag;
	
    
end$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_timer_deamon
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_timer_deamon`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_timer_deamon`()
begin

declare last_time datetime default '2012-1-1 00:00:00';
declare cur_time datetime; 
declare active_template int default null;


select LastTime into last_time from LastProcessedTime where LastTimeID = 1;


select InfoValue into active_template from BaseInfo where InfomationID = 0x101;
set  cur_time = now();

if ((last_time > cur_time) or (timestampdiff(second, last_time, cur_time) > 10)) then
    set last_time = timestampadd(second, -2, cur_time);
 end if;   
 

delete from Messages where abs(timestampdiff(second, MsgTime, cur_time)) > 10;


update BroadcastMode set
             Active = ! Active
             where (Enabled = true) and
                            (func_check_mode_daytime(TimeStyle, 
                                                     case when Active = false then StartTime else StopTime end, 
                                                     last_time, cur_time) = true);
             

insert into DeviceDesiredStaus(DeviceID, BrdMode, ModePriority)
        select  DeviceID, BrdModeID, Priority from v_DeviceModes
        on duplicate key update BrdMode = values(BrdMode), ModePriority = values(ModePriority);
                      
 
update PlaySessionTime
                 left join PlaySessions on PlaySessionTime.SessionID = PlaySessions.SessionID
                 set PlaySessionTime.TempFlag = sp_session_start(PlaySessions.SessionID, PlaySessionTime.ScheduleID, 
                                                                 PlaySessionTime.TempFlag,
                                                                 PlaySessions.StreamType, PlaySessions.BrdMode, 
                                                                 PlaySessions.MemberMode, 
                                                                 PlaySessions.SysEnabled, 
                                                                 PlaySessions.RfDevCtrl)
  where ((PlaySessions.BrdMode > 0) or (PlaySessions.Owner != 0) or (active_template = PlaySessions.Template) or (PlaySessions.SessionType = 10)) and
        ( func_check_session_daytime(PlaySessions.BrdMode, PlaySessionTime. WeekDay, 
                                     PlaySessionTime.PlayTime, last_time, cur_time)  = true);

delete from PlaySessionTime where TempFlag = 127;
 
 
delete from AlternateDate where date(cur_time) > SpecialDate;

update PlaySessions, PlayerStatus, PlayerAlive set PlayerStatus.SessionID = 0
where (PlaySessions.PlayerID = PlayerAlive.PlayerID) 
    and (PlayerStatus.SessionID = PlaySessions.SessionID)
    and (PlaySessions.SessionType = 10)
    and timestampdiff(second, PlayerAlive.RefreshTime, cur_time) > 10;

delete PlayerStatus,  PlayerAlive from PlayerStatus,  PlayerAlive
where (PlayerStatus.PlayerID = PlayerAlive.PlayerID) and  
             timestampdiff(second, PlayerAlive.RefreshTime, cur_time) > 10;

update PlayingSessions set CurrTotalProgress = (case when CurrTotalProgress is null then 1 else CurrTotalProgress + 1 end)
        where SesType = 10;
delete from PlayingSessions where SesType = 10 and (CircleLength > 0 and CurrTotalProgress > CircleLength);

if (to_days(last_time) <> to_days(cur_time)) then
	delete PlaySessions from PlaySessions 
			where (SessionType = 0 or SessionType = 8) and 
               (not exists (select ScheduleID from PlaySessionTime where SessionID = PlaySessions.SessionID)) and
               (not exists (select PlayerID from PlayingSessions where SessionID = PlaySessions.SessionID) );
end if;
      
insert into LastProcessedTime(LastTimeID, LastTime) values (1, cur_time) 
              on duplicate key update LastTime = values(LastTime);



end$$

DELIMITER ;

-- -----------------------------------------------------
-- procedure sp_update_dev_session
-- -----------------------------------------------------

USE `nccs`;
DROP procedure IF EXISTS `nccs`.`sp_update_dev_session`;

DELIMITER $$
USE `nccs`$$
CREATE DEFINER=`root`@`%` PROCEDURE `sp_update_dev_session`(dev_id varchar(50))
begin
 declare modeid int default 0; 
 declare modepriority int default null;
 declare sessionid smallint unsigned default null;
 declare sessionport int default 0; 
 declare sessiontype tinyint default 0; 
 declare streamType tinyint unsigned default 1; 
 declare valid boolean default false; 

 
 
 select DeviceDesiredStaus.SessionValid,  DeviceDesiredStaus.BrdMode, BroadcastMode.Priority
               into valid, modeid,  modepriority from DeviceDesiredStaus 
               left join BroadcastMode on BroadcastMode.idBroadcastMode = DeviceDesiredStaus.BrdMode
               where DeviceID = dev_id;
   
  if  not (valid=true) then
                
       select SessionList.SessionID,  SessionList.MultiPort , SessionList.SesType,SessionList.StreamType
                 into  sessionid, sessionport , sessiontype, streamType from 
                       (select PlaySessions.SessionID,  PlaySessions.Priority,  PlayingSessions.PlayerID,  
                                        PlayingSessions.MultiPort , PlaySessions.BrdMode, PlaySessions.MemberMode, 
                                        PlayingSessions.SesType, PlayingSessions.StreamType
                                  from PlayingSessions 
                                  left join PlaySessions on PlayingSessions.SessionID = PlaySessions.SessionID 
                                  where   (func_check_dev_stream(dev_id,PlayingSessions.StreamType) = true) and
                                                   (((modeid = 0 or modeid is null ) and (PlaySessions.MemberMode = false) )
                                                               or (PlaySessions.Priority < modepriority) or (PlaySessions.BrdMode = modeid))) 
                                as SessionList                   
               left join SessionDevice on (SessionDevice.DeviceID = dev_id) and 
                                                                      (SessionDevice.SessionID = SessionList.SessionID) and
                                                                      (not DevDisabled = 1)
               left join  PlayerKeys on PlayerKeys.PlayerID = SessionList.PlayerID  and PlayerKeys.GroupDisable = 0                                                    
               where
                            (SessionDevice.DeviceID  is not null) or (SessionList.BrdMode = modeid and  SessionList.MemberMode = true) or
                             (PlayerKeys.GroupID is not null and sp_dev_belong_group(dev_id , PlayerKeys.GroupID))  
                      order by SessionList.Priority, SessionList.SessionID LIMIT 1;
                      
      insert into DeviceDesiredStaus (DeviceID, SessionID, BrdPort,  SessionType, StreamType, SessionValid)
              values(dev_id, sessionid, sessionport,  sessiontype, streamType, true)
              on duplicate key update                       
                  SessionID = values(SessionID), BrdPort = values(BrdPort), 
                  SessionType=values(SessionType),
                  StreamType = values(StreamType),  SessionValid = values(SessionValid);
              
 end if;
 
 
 
select a.SessionID, a.BrdPort, a.SessionType, a.StreamType, a.SysEnabled, b.NetworkID , a.RfDevCtrl, c.SessionName, a.IpCall, a.IpCallPort
                 from DeviceDesiredStaus as a 
                     left join DeviceStatus b on a.DeviceID=b.DeviceID 
                     left join PlaySessions c on a.SessionID= c.SessionID
                          where a.DeviceID = dev_id;
  
end$$

DELIMITER ;

-- -----------------------------------------------------
-- View `nccs`.`v_DeviceModes`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_DeviceModes` ;
DROP TABLE IF EXISTS `nccs`.`v_DeviceModes`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_DeviceModes` AS select `a`.`DevID` AS `DeviceID`,`b`.`BrdModeID` AS `BrdModeID`,`b`.`Priority` AS `Priority` from ((`nccs`.`DeviceList` `a` left join `nccs`.`v_active_mode_members` `b` on((`b`.`DeviceID` = `a`.`DevID`))) left join `nccs`.`v_active_mode_members` `c` on(((`c`.`DeviceID` = `a`.`DevID`) and (`c`.`Priority` < `b`.`Priority`)))) where isnull(`c`.`Priority`);

-- -----------------------------------------------------
-- View `nccs`.`v_Session_Files`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_Session_Files` ;
DROP TABLE IF EXISTS `nccs`.`v_Session_Files`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_Session_Files` AS select `a`.`SessionID` AS `SessionID`,`a`.`SessionName` AS `SessionName`,`b`.`FileID` AS `FileID`,`b`.`SequenceID` AS `SequenceID`,`c`.`FileName` AS `FileName`,`c`.`TotalTime` AS `TotalTime`,`b`.`Duration` AS `PlayTime`,`c`.`Gain` AS `Gain`,`c`.`FileFmt` AS `FileFmt`,`c`.`FilePath` AS `FilePath` from ((`nccs`.`PlaySessions` `a` left join `nccs`.`PlayListFiles` `b` on((`a`.`SessionID` = `b`.`SessionID`))) left join `nccs`.`MediaFiles` `c` on((`b`.`FileID` = `c`.`MediaID`))) where (`b`.`FileID` is not null);

-- -----------------------------------------------------
-- View `nccs`.`v_active_mode_members`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_active_mode_members` ;
DROP TABLE IF EXISTS `nccs`.`v_active_mode_members`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_active_mode_members` AS select `nccs`.`BrdModeMember`.`DeviceID` AS `DeviceID`,`nccs`.`BroadcastMode`.`idBroadcastMode` AS `BrdModeID`,`nccs`.`BroadcastMode`.`Priority` AS `Priority` from (`nccs`.`BroadcastMode` left join `nccs`.`BrdModeMember` on((`nccs`.`BroadcastMode`.`idBroadcastMode` = `nccs`.`BrdModeMember`.`BrdModeID`))) where (`nccs`.`BroadcastMode`.`Active` = 1);

-- -----------------------------------------------------
-- View `nccs`.`v_device`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_device` ;
DROP TABLE IF EXISTS `nccs`.`v_device`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_device` AS select `nccs`.`DeviceList`.`DevID` AS `id`,`nccs`.`DeviceList`.`Dev_Name` AS `name`,`nccs`.`DeviceList`.`Parent` AS `parent`,convert(`nccs`.`DeviceList`.`Dev_Description` using gb2312) AS `description`,`nccs`.`DeviceStatus`.`IpAddress` AS `ipaddress`,`nccs`.`DeviceStatus`.`ShouldSessionID` AS `shouldSession`,`nccs`.`DeviceStatus`.`ActualSessionID` AS `actualSession`,`nccs`.`DeviceStatus`.`Version` AS `version`,`nccs`.`PlaySessions`.`SessionName` AS `sessionName`,(case `nccs`.`DeviceStatus`.`State_SysPower` when 0 then 'off' when 1 then 'on' when 2 then 'disable' else `nccs`.`DeviceStatus`.`State_SysPower` end) AS `power`,(case `nccs`.`DeviceStatus`.`State_ProjectorStatus` when 0 then 'off' when 1 then 'on' when 2 then 'poweron' when 3 then 'shutdown' else `nccs`.`DeviceStatus`.`State_ProjectorStatus` end) AS `projector`,(case `nccs`.`DeviceStatus`.`State_ProjectorLampStatus` when 0 then 'off' when 1 then 'on' else `nccs`.`DeviceStatus`.`State_ProjectorLampStatus` end) AS `projectorLamp`,(case `nccs`.`DeviceStatus`.`State_ExDevice1Status` when 0 then 'off' when 1 then 'on' else `nccs`.`DeviceStatus`.`State_ExDevice1Status` end) AS `exDevice1`,(case `nccs`.`DeviceStatus`.`State_ExDevice2Status` when 0 then 'off' when 1 then 'on' else `nccs`.`DeviceStatus`.`State_ExDevice2Status` end) AS `exDevice2`,(case `nccs`.`DeviceStatus`.`State_CurrProjectorSrc` when 1 then 'pc' when 2 then 'extend' when 3 then 'visualizer' when 4 then 'broadcast' else `nccs`.`DeviceStatus`.`State_CurrProjectorSrc` end) AS `projectorSrc`,(case `nccs`.`DeviceStatus`.`State_CurrAudio` when 0 then 'pc' when 1 then 'extend' when 2 then 'visualizer' when 3 then 'broadcast' else `nccs`.`DeviceStatus`.`State_CurrAudio` end) AS `audioSrc`,`nccs`.`DeviceStatus`.`State_CurrAudioVolume` AS `audioVol`,`nccs`.`DeviceStatus`.`State_CurrMicVolume` AS `micVol`,`nccs`.`DeviceStatus`.`State_FaultStatus` AS `fault`,(case `nccs`.`DeviceStatus`.`State_MicState` when 1 then 'off' else 'on' end) AS `micMute`,(case `nccs`.`DeviceStatus`.`State_Mute` when 0 then 'off' else 'on' end) AS `audioMute`,(case `nccs`.`DeviceStatus`.`State_Pc` when 0 then 'off' else 'on' end) AS `pc`,hex(`nccs`.`DeviceStatus`.`RfDevStatus`) AS `iotStatus`,ifnull(`nccs`.`Users`.`User_Desc`,`nccs`.`Users`.`User_Name`) AS `userName`,(case (`nccs`.`DeviceStatus`.`IpCallStatus` & 0x87) when 0x80 then 'idle' when 0x81 then 'ringing' when 0x82 then 'talking' when 0x83 then 'onhook' when 0x84 then 'listen' else (case (`nccs`.`DeviceStatus`.`IpCallStatus` & 0x80) when 0 then 'offline' else `nccs`.`DeviceStatus`.`IpCallStatus` end) end) AS `ipcall`,if(isnull(`nccs`.`DeviceStatus`.`IpAddress`),NULL,`nccs`.`BroadcastMode`.`ModeName`) AS `ModeName`,`nccs`.`DeviceDesiredStaus`.`ModePriority` AS `ModePriority`,if((isnull(`nccs`.`DeviceList`.`RtspUrl`) or isnull(`nccs`.`DeviceList`.`RtspSub`)),NULL,'set') AS `rtsp`,if((isnull(`nccs`.`DeviceList`.`RtspUrl1`) or isnull(`nccs`.`DeviceList`.`RtspSub1`)),NULL,'set') AS `rtsp1`,if((`nccs`.`DeviceList`.`ProjWatermark` < `nccs`.`DeviceList`.`ProjUsedTime`),`nccs`.`DeviceList`.`ProjUsedTime`,NULL) AS `ProjAlert`,if(isnull(`nccs`.`DeviceStatus`.`Temperature`),NULL,`nccs`.`DeviceStatus`.`Temperature`) AS `Temperature`,if(isnull(`nccs`.`DeviceStatus`.`Humidity`),NULL,`nccs`.`DeviceStatus`.`Humidity`) AS `Humidity`,if((isnull(`nccs`.`DeviceList`.`PcIp`) or isnull(`nccs`.`DeviceList`.`PcPort`) or isnull(`nccs`.`DeviceList`.`PcMainPasswd`)),NULL,'set') AS `pcCtrl` from (((((`nccs`.`DeviceList` left join `nccs`.`DeviceStatus` on((`nccs`.`DeviceList`.`DevID` = `nccs`.`DeviceStatus`.`DeviceID`))) left join `nccs`.`DeviceDesiredStaus` on((`nccs`.`DeviceList`.`DevID` = `nccs`.`DeviceDesiredStaus`.`DeviceID`))) left join `nccs`.`BroadcastMode` on((`nccs`.`BroadcastMode`.`idBroadcastMode` = `nccs`.`DeviceDesiredStaus`.`BrdMode`))) left join `nccs`.`Users` on(((`nccs`.`DeviceStatus`.`User_ID` is not null) and (`nccs`.`Users`.`User_ID` = `nccs`.`DeviceStatus`.`User_ID`)))) left join `nccs`.`PlaySessions` on((`nccs`.`PlaySessions`.`SessionID` = `nccs`.`DeviceStatus`.`ActualSessionID`))) order by `nccs`.`DeviceStatus`.`IpAddress` desc;

-- -----------------------------------------------------
-- View `nccs`.`v_device_classes`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_device_classes` ;
DROP TABLE IF EXISTS `nccs`.`v_device_classes`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_device_classes` AS select `nccs`.`DevClasses`.`ClassID` AS `ClassID`,`nccs`.`DevClasses`.`Name` AS `Name`,`nccs`.`DevClasses`.`Parent` AS `Parent`,`nccs`.`DeviceList`.`DevID` AS `DevID`,`nccs`.`DeviceList`.`Dev_Name` AS `Dev_Name` from (`nccs`.`DevClasses` left join `nccs`.`DeviceList` on((`nccs`.`DeviceList`.`Parent` = `nccs`.`DevClasses`.`ClassID`)));

-- -----------------------------------------------------
-- View `nccs`.`v_device_log`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_device_log` ;
DROP TABLE IF EXISTS `nccs`.`v_device_log`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_device_log` AS select `a`.`DevLogID` AS `DevLogID`,`a`.`DeviceID` AS `DeviceID`,`c`.`Dev_Name` AS `DeviceName`,`a`.`DateTime` AS `DateTime`,`a`.`Event` AS `Event`,`a`.`CtrlUser` AS `CtrlUser`,ifnull(`b`.`User_Desc`,`b`.`User_Name`) AS `User_Name`,`b`.`User_Sn` AS `User_Sn`,`a`.`MsgContext` AS `MsgContext`,`a`.`EndTime` AS `EndTime`,(case `a`.`EndTime` when NULL then NULL else timediff(`a`.`EndTime`,`a`.`DateTime`) end) AS `Length` from ((`nccs`.`DeviceLog` `a` left join `nccs`.`Users` `b` on((`b`.`User_ID` = `a`.`CtrlUser`))) left join `nccs`.`DeviceList` `c` on((`c`.`DevID` = `a`.`DeviceID`))) order by `a`.`DevLogID` desc;

-- -----------------------------------------------------
-- View `nccs`.`v_device_message`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_device_message` ;
DROP TABLE IF EXISTS `nccs`.`v_device_message`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_device_message` AS select `b`.`MsgID` AS `message`,`v_device`.`id` AS `id`,`v_device`.`name` AS `name`,`v_device`.`parent` AS `parent`,`v_device`.`description` AS `description`,`v_device`.`ipaddress` AS `ipaddress`,`v_device`.`shouldSession` AS `shouldSession`,`v_device`.`actualSession` AS `actualSession`,`v_device`.`sessionName` AS `sessionName`,`v_device`.`power` AS `power`,`v_device`.`projector` AS `projector`,`v_device`.`projectorLamp` AS `projectorLamp`,`v_device`.`exDevice1` AS `exDevice1`,`v_device`.`exDevice2` AS `exDevice2`,`v_device`.`projectorSrc` AS `projectorSrc`,`v_device`.`audioSrc` AS `audioSrc`,`v_device`.`audioVol` AS `audioVol`,`v_device`.`micVol` AS `micVol`,`v_device`.`fault` AS `fault`,`v_device`.`micMute` AS `micMute`,`v_device`.`audioMute` AS `audioMute`,`v_device`.`pc` AS `pc`,`v_device`.`iotStatus` AS `iotStatus`,`v_device`.`userName` AS `userName`,`v_device`.`ipcall` AS `ipcall`,`v_device`.`ModeName` AS `ModeName`,`v_device`.`Temperature` AS `Temperature`,`v_device`.`Humidity` AS `Humidity` from (((select max(`nccs`.`Messages`.`ID`) AS `MsgID`,`nccs`.`Messages`.`CmdObjID` AS `DeviceID` from `nccs`.`Messages` where ((`nccs`.`Messages`.`MsgType` = 3) and (`nccs`.`Messages`.`CmdObjID` is not null)) group by `nccs`.`Messages`.`CmdObjID`)) `b` left join `nccs`.`v_device` on((`v_device`.`id` = `b`.`DeviceID`))) where (`v_device`.`id` is not null) order by `b`.`MsgID` desc;

-- -----------------------------------------------------
-- View `nccs`.`v_device_statistic`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_device_statistic` ;
DROP TABLE IF EXISTS `nccs`.`v_device_statistic`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_device_statistic` AS select `c`.`DeviceID` AS `DeviceID`,`c`.`DeviceName` AS `DeviceName`,`c`.`StatisticDay` AS `StatisticDay`,conv(substr(`c`.`power`,1,8),16,10) AS `power0`,conv(substr(`c`.`power`,9,8),16,10) AS `power1`,conv(substr(`c`.`power`,17,8),16,10) AS `power2`,conv(substr(`c`.`power`,25,8),16,10) AS `power3`,conv(substr(`c`.`power`,33,8),16,10) AS `power4`,conv(substr(`c`.`power`,41,8),16,10) AS `power5`,conv(substr(`c`.`power`,49,8),16,10) AS `power6`,conv(substr(`c`.`power`,57,8),16,10) AS `power7`,conv(substr(`c`.`power`,65,8),16,10) AS `power8`,conv(substr(`c`.`power`,73,8),16,10) AS `power9`,conv(substr(`c`.`power`,81,8),16,10) AS `power10`,conv(substr(`c`.`power`,89,8),16,10) AS `power11`,conv(substr(`c`.`power`,97,8),16,10) AS `power12`,conv(substr(`c`.`power`,105,8),16,10) AS `power13`,conv(substr(`c`.`power`,113,8),16,10) AS `power14`,conv(substr(`c`.`power`,121,8),16,10) AS `power15`,conv(substr(`c`.`time`,1,8),16,10) AS `time0`,conv(substr(`c`.`time`,9,8),16,10) AS `time1`,conv(substr(`c`.`time`,17,8),16,10) AS `time2`,conv(substr(`c`.`time`,25,8),16,10) AS `time3`,conv(substr(`c`.`time`,33,8),16,10) AS `time4`,conv(substr(`c`.`time`,41,8),16,10) AS `time5`,conv(substr(`c`.`time`,49,8),16,10) AS `time6`,conv(substr(`c`.`time`,57,8),16,10) AS `time7`,conv(substr(`c`.`time`,65,8),16,10) AS `time8`,conv(substr(`c`.`time`,73,8),16,10) AS `time9`,conv(substr(`c`.`time`,81,8),16,10) AS `time10`,conv(substr(`c`.`time`,89,8),16,10) AS `time11`,conv(substr(`c`.`time`,97,8),16,10) AS `time12`,conv(substr(`c`.`time`,105,8),16,10) AS `time13`,conv(substr(`c`.`time`,113,8),16,10) AS `time14`,conv(substr(`c`.`time`,121,8),16,10) AS `time15` from (select `a`.`DeviceID` AS `DeviceID`,`b`.`Dev_Name` AS `DeviceName`,`a`.`StatisticDay` AS `StatisticDay`,hex(`a`.`UsedTime`) AS `time`,hex(`a`.`PowerConsumed`) AS `power` from (`nccs`.`DeviceStatistic` `a` left join `nccs`.`DeviceList` `b` on((`b`.`DevID` = `a`.`DeviceID`)))) `c`;

-- -----------------------------------------------------
-- View `nccs`.`v_event`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_event` ;
DROP TABLE IF EXISTS `nccs`.`v_event`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_event` AS select `a`.`Id` AS `Id`,`a`.`Name` AS `Name`,`a`.`StartTask` AS `StartTask`,`b`.`SessionName` AS `StartTaskName`,`a`.`EndTask` AS `EndTask`,`c`.`SessionName` AS `EndTaskName`,hex(`a`.`Config`) AS `Config`,`a`.`Model` AS `Model`,`d`.`Manufacturer` AS `Manufacturer`,`d`.`Model` AS `ModelName`,`a`.`Version` AS `Version` from (((`nccs`.`Event` `a` left join `nccs`.`PlaySessions` `b` on((`b`.`SessionID` = `a`.`StartTask`))) left join `nccs`.`PlaySessions` `c` on((`c`.`SessionID` = `a`.`EndTask`))) left join `nccs`.`EventModel` `d` on((`d`.`id` = `a`.`Model`)));

-- -----------------------------------------------------
-- View `nccs`.`v_ip_call`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_ip_call` ;
DROP TABLE IF EXISTS `nccs`.`v_ip_call`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_ip_call` AS select `a`.`id` AS `id`,`a`.`device` AS `device`,`b`.`Dev_Name` AS `deviceName`,`a`.`waiter` AS `waiter`,`d`.`User_Name` AS `waiterName`,`a`.`audioPort` AS `audioPort`,`a`.`ringing` AS `ringing`,`a`.`status` AS `status`,`a`.`direction` AS `direction`,`a`.`webrtcUpdate` AS `webrtcUpdate`,`a`.`webrtcStatus` AS `webrtcStatus`,`a`.`wsPort` AS `wsPort` from (((`nccs`.`IpCall` `a` left join `nccs`.`DeviceList` `b` on((`b`.`DevID` = `a`.`device`))) left join `nccs`.`CallWaiter` `c` on((`c`.`id` = `a`.`waiter`))) left join `nccs`.`Users` `d` on((`c`.`user` = `d`.`User_ID`)));

-- -----------------------------------------------------
-- View `nccs`.`v_media_files`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_media_files` ;
DROP TABLE IF EXISTS `nccs`.`v_media_files`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_media_files` AS select `a`.`MediaID` AS `MediaID`,`a`.`FileName` AS `FileName`,`a`.`FileSize` AS `FileSize`,`a`.`TotalTime` AS `TotalTime`,`a`.`FileFmt` AS `FileFmt`,`a`.`BitRate` AS `BitRate`,`a`.`VedioCodec` AS `VedioCodec`,`a`.`Height` AS `Height`,`a`.`Width` AS `Width`,`a`.`FrameRate` AS `FrameRate`,`a`.`AudioCodec` AS `AudioCodec`,`a`.`Channels` AS `Channels`,`a`.`SampleRate` AS `SampleRate`,`a`.`Parent` AS `Parent`,`a`.`Gain` AS `Gain`,`a`.`CreateTime` AS `CreateTime`,`a`.`FilePath` AS `FilePath`,`a`.`Owner` AS `Owner`,`c`.`User_Desc` AS `OwnerName`,`a`.`Sysfolder` AS `Sysfolder` from (`nccs`.`MediaFiles` `a` left join `nccs`.`Users` `c` on((`c`.`User_ID` = `a`.`Owner`))) where (isnull(`a`.`Sysfolder`) or (`a`.`Sysfolder` >= 0) or ((`a`.`Sysfolder` = -(1)) and (`a`.`VedioCodec` = -(1)) and (`a`.`AudioCodec` = -(1))));

-- -----------------------------------------------------
-- View `nccs`.`v_play_session_time_group`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_play_session_time_group` ;
DROP TABLE IF EXISTS `nccs`.`v_play_session_time_group`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_play_session_time_group` AS (select `a`.`SessionID` AS `SessionID`,cast(`a`.`PlayTime` as time) AS `PlayTime`,group_concat(`a`.`WeekDay` separator ',') AS `WeekDay`,group_concat(`a`.`TempFlag` separator ',') AS `TempFlag`,group_concat(`a`.`ScheduleID` separator ',') AS `ScheduleID` from `nccs`.`PlaySessionTime` `a` group by `a`.`SessionID`,`a`.`PlayTime`);

-- -----------------------------------------------------
-- View `nccs`.`v_player_keys`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_player_keys` ;
DROP TABLE IF EXISTS `nccs`.`v_player_keys`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_player_keys` AS select `a`.`PlayerKeyId` AS `PlayerKeyId`,`a`.`PlayerID` AS `PlayerID`,`a`.`Index` AS `Index`,`a`.`GroupDisable` AS `GroupDisable`,`a`.`DevDisable` AS `DevDisable`,`a`.`GroupID` AS `GroupID`,`b`.`Name` AS `GroupName` from (`nccs`.`PlayerKeys` `a` left join `nccs`.`DevClasses` `b` on((`b`.`ClassID` = `a`.`GroupID`)));

-- -----------------------------------------------------
-- View `nccs`.`v_playing_sessions`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_playing_sessions` ;
DROP TABLE IF EXISTS `nccs`.`v_playing_sessions`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_playing_sessions` AS select `a`.`SessionID` AS `SessionID`,`a`.`PlayerID` AS `PlayerID`,`a`.`PlayingFileID` AS `PlayingFileID`,`b`.`FileName` AS `FileName`,`a`.`MultiPort` AS `MultiPort`,`a`.`CircleLength` AS `CircleLength`,`a`.`CurrFileProgress` AS `CurrFileProgress`,`a`.`CurrTotalProgress` AS `CurrTotalProgress`,`a`.`Priority` AS `Priority`,`a`.`Pause` AS `Pause`,`a`.`ScheduleID` AS `ScheduleID`,`d`.`WeekDay` AS `WeekDay`,cast(`d`.`PlayTime` as time) AS `PlayTime`,`c`.`Template` AS `Template`,`a`.`BrdMode` AS `BrdMode`,`a`.`SesType` AS `SessionType`,`a`.`StreamType` AS `StreamType` from (((`nccs`.`PlayingSessions` `a` left join `nccs`.`MediaFiles` `b` on((`a`.`PlayingFileID` = `b`.`MediaID`))) left join `nccs`.`PlaySessions` `c` on((`c`.`SessionID` = `a`.`SessionID`))) left join `nccs`.`PlaySessionTime` `d` on((`d`.`ScheduleID` = `a`.`ScheduleID`)));

-- -----------------------------------------------------
-- View `nccs`.`v_session_info`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_session_info` ;
DROP TABLE IF EXISTS `nccs`.`v_session_info`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_session_info` AS select `a`.`SessionID` AS `SessionID`,`a`.`SessionName` AS `SessionName`,`a`.`SessionType` AS `SessionType`,`a`.`Priority` AS `Priority`,`a`.`CircleLength` AS `CircleLength`,`a`.`PlayerID` AS `PlayerID`,`a`.`BrdMode` AS `BrdMode`,`a`.`MemberMode` AS `MemberMode`,`a`.`StreamType` AS `StreamType`,`a`.`SysEnabled` AS `SysEnabled`,hex(`a`.`RfDevCtrl`) AS `RfDevCtrl`,`a`.`Owner` AS `Owner`,if(isnull(`d`.`User_Desc`),`d`.`User_Name`,`d`.`User_Desc`) AS `OwnerName`,`a`.`PlayMode` AS `PlayMode`,`a`.`AudioGain` AS `AudioGain`,`a`.`Template` AS `Template`,`b`.`FileID` AS `FileID`,`c`.`IpAddress` AS `PlayerAddress`,`c`.`PlayType` AS `PlayType`,`e`.`PlayerType` AS `PlayerType`,(case when ((`a`.`RfDevCtrl` is not null) or (`a`.`SysEnabled` is not null)) then 'ctrl' else 'brd' end) AS `Type` from ((((`nccs`.`PlaySessions` `a` left join `nccs`.`PlayListFiles` `b` on(((`b`.`SessionID` = `a`.`SessionID`) and (`b`.`SequenceID` = 0)))) left join `nccs`.`PlayerStatus` `c` on((`c`.`PlayerID` = `a`.`PlayerID`))) left join `nccs`.`Users` `d` on((`d`.`User_ID` = `a`.`Owner`))) left join `nccs`.`Players` `e` on((`e`.`PlayerID` = `a`.`PlayerID`)));

-- -----------------------------------------------------
-- View `nccs`.`v_session_schedules`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_session_schedules` ;
DROP TABLE IF EXISTS `nccs`.`v_session_schedules`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_session_schedules` AS select `a`.`ScheduleID` AS `ScheduleID`,`a`.`TempFlag` AS `TempFlag`,`a`.`PlayTime` AS `PlayTime`,`a`.`WeekDay` AS `WeekDay`,`b`.`SessionID` AS `SessionID`,`b`.`SessionName` AS `SessionName`,`c`.`Pause` AS `Pause`,`b`.`BrdMode` AS `BrdMode`,`b`.`SessionType` AS `SessionType`,`b`.`SysEnabled` AS `SysEnabled`,`b`.`RfDevCtrl` AS `RfDevCtrl`,`b`.`StreamType` AS `StreamType` from ((`nccs`.`PlaySessionTime` `a` left join `nccs`.`PlaySessions` `b` on((`a`.`SessionID` = `b`.`SessionID`))) left join `nccs`.`PlayingSessions` `c` on((`a`.`ScheduleID` = `c`.`ScheduleID`)));

-- -----------------------------------------------------
-- View `nccs`.`v_stream_trans_table`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_stream_trans_table` ;
DROP TABLE IF EXISTS `nccs`.`v_stream_trans_table`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_stream_trans_table` AS select `a`.`NetworkID` AS `NetworkID`,`a`.`IpAddress` AS `proxy`,`b`.`IpAddress` AS `IpAddress`,`c`.`MultiPort` AS `MultiPort`,`c`.`SessionID` AS `SessionID` from ((`nccs`.`DeviceStatus` `a` left join `nccs`.`SubNetwork` `b` on((`b`.`idSubNetwork` = `a`.`NetworkID`))) left join `nccs`.`PlayingSessions` `c` on((`c`.`SessionID` = `a`.`ActualSessionID`))) where (`a`.`ActualSessionID` > 0) group by `c`.`SessionID`,`a`.`NetworkID`;

-- -----------------------------------------------------
-- View `nccs`.`v_timed_session_info`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_timed_session_info` ;
DROP TABLE IF EXISTS `nccs`.`v_timed_session_info`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_timed_session_info` AS select `a`.`SessionID` AS `SessionID`,`a`.`SessionName` AS `SessionName`,`a`.`SessionType` AS `SessionType`,`a`.`Priority` AS `Priority`,`a`.`BrdMode` AS `BrdMode`,`a`.`StreamType` AS `StreamType`,`a`.`Owner` AS `Owner`,`a`.`OwnerName` AS `OwnerName`,`a`.`PlayMode` AS `PlayMode`,`a`.`Template` AS `Template`,`a`.`FileID` AS `FileID`,`d`.`PlayTime` AS `PlayTime`,`d`.`WeekDay` AS `WeekDay`,`d`.`TempFlag` AS `TempFlag`,`d`.`ScheduleID` AS `ScheduleID`,`a`.`Type` AS `Type` from (`nccs`.`v_play_session_time_group` `d` left join `nccs`.`v_session_info` `a` on((`d`.`SessionID` = `a`.`SessionID`))) where (`a`.`SessionType` in (0,8));

-- -----------------------------------------------------
-- View `nccs`.`v_timetable`
-- -----------------------------------------------------
DROP VIEW IF EXISTS `nccs`.`v_timetable` ;
DROP TABLE IF EXISTS `nccs`.`v_timetable`;
USE `nccs`;
CREATE  OR REPLACE ALGORITHM=UNDEFINED DEFINER=`root`@`%` SQL SECURITY DEFINER VIEW `nccs`.`v_timetable` AS select `a`.`Id` AS `Id`,`a`.`DevId` AS `DevId`,`b`.`Dev_Name` AS `Dev_Name`,`a`.`UserId` AS `UserId`,ifnull(`c`.`User_Desc`,`c`.`User_Name`) AS `User_Name`,`a`.`WeekDay` AS `WeekDay`,`a`.`Start` AS `Start`,`a`.`End` AS `End`,`a`.`Type` AS `Type`,`a`.`OneTime` AS `OneTime`,`a`.`Sync` AS `Sync` from ((`nccs`.`Timetable` `a` left join `nccs`.`DeviceList` `b` on((`a`.`DevId` = `b`.`DevID`))) left join `nccs`.`Users` `c` on((`c`.`User_ID` = `a`.`UserId`)));
USE `nccs`;

DELIMITER $$

USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`BaseInfo_BINS` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`BaseInfo_BINS`
BEFORE INSERT ON `nccs`.`BaseInfo`
FOR EACH ROW
begin
    if  (new.InfomationID = 0) then
        set new.InfoValue = 1;
    end if;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`BaseInfo_BUPD` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`BaseInfo_BUPD`
BEFORE UPDATE ON `nccs`.`BaseInfo`
FOR EACH ROW
begin
    if  (new.InfomationID = 0) and ((old.Description <> new.Description)) then
        set new.InfoValue = 1;
    end if;
    if (new.InfomationID >= 1) and (new.InfomationID <= 4) then
        select send_msg_to_srv(179, null) into @ret;
    end if;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_brdmode_delete` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`localhost`
TRIGGER `nccs`.`tr_brdmode_delete`
BEFORE DELETE ON `nccs`.`BroadcastMode`
FOR EACH ROW
begin
     delete from PlaySessions  where BrdMode = old.idBroadcastMode;
     delete from BrdModeMember where BrdModeID = old.idBroadcastMode;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_brdmode_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_brdmode_update`
AFTER UPDATE ON `nccs`.`BroadcastMode`
FOR EACH ROW
begin
                                  
    if  not (new.Priority = old.Priority) then
        update PlaySessions set Priority =  new.Priority where BrdMode = old.idBroadcastMode  and  (PlaySessions.Priority > new.Priority);
    end if;
    insert into Messages Values (0, 1, 2, 12, now(), null, new.idBroadcastMode, null, null);   
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_brdmode_update1` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_brdmode_update1`
BEFORE UPDATE ON `nccs`.`BroadcastMode`
FOR EACH ROW
begin
    if (new.Enabled = false) then
            set new.Active = false;
      end if;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_devclasses_delete` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_devclasses_delete`
BEFORE DELETE ON `nccs`.`DevClasses`
FOR EACH ROW
begin
     delete from GroupCtrlSchedule where GroupID = old.ClassID;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_devclasses_insert` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_devclasses_insert`
BEFORE INSERT ON `nccs`.`DevClasses`
FOR EACH ROW
begin
     declare count int default 0;
     declare parentid int default 0;
     
     set parentid = new.Parent;
     
     while (parentid is not null)  and (parentid <> 0) and (count < 5) do
      select Parent  into parentid from  DevClasses where ClassID = parentid;
      set count = count + 1;
     end while;
     
     if (count >= 5) then 
     insert DevClasses values(0,' ',0);
     end if;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_devclasses_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`localhost`
TRIGGER `nccs`.`tr_devclasses_update`
AFTER UPDATE ON `nccs`.`DevClasses`
FOR EACH ROW
begin
     declare count int default 0;
     declare parentid int default 0;
     
     set parentid = new.Parent;
     
     while (parentid is not null)  and (parentid <> 0) and (count < 5) do
      select Parent  into parentid from  DevClasses where ClassID = parentid;
      set count = count + 1;
     end while;
     
     if (count >= 5) then 
     insert DevClasses values(0,' ',0);
     end if;
     
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`DeviceList_AUPD` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`localhost`
TRIGGER `nccs`.`DeviceList_AUPD`
AFTER UPDATE ON `nccs`.`DeviceList`
FOR EACH ROW
begin
    insert into Messages Values (0, 1, 2, 3, now(), 0, 0, new.DevID, NULL);  
    update DeviceDesiredStaus set  DeviceDesiredStaus.SessionValid = false  
               where  DeviceDesiredStaus.DeviceID = new.DevID;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_devicelist_delete` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_devicelist_delete`
BEFORE DELETE ON `nccs`.`DeviceList`
FOR EACH ROW
begin
     delete from DevCtrlSchedule where DevID = old.DevID;
     delete from DeviceDesiredStaus where DeviceID =  old.DevID;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`DeviceDesiredStaus_After_Update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`localhost`
TRIGGER `nccs`.`DeviceDesiredStaus_After_Update`
AFTER UPDATE ON `nccs`.`DeviceDesiredStaus`
FOR EACH ROW
begin
	declare ret integer;
    select send_msg_to_srv(161, new.DeviceID) into ret;
    if(old.BrdMode <> new.BrdMode) or ((old.BrdMode is null) and (new.BrdMode is not null)) or ((old.BrdMode is not null) and (new.BrdMode is null))  then
        insert into Messages Values (0, 1, 2, 3, now(), 0, 0, new.DeviceID, NULL);
    end if;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_DeviceDesiredStaus_after_insert` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_DeviceDesiredStaus_after_insert`
AFTER INSERT ON `nccs`.`DeviceDesiredStaus`
FOR EACH ROW
BEGIN
    select send_msg_to_srv(161, new.DeviceID) into @ret;
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_DeviceDesiredStaus_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_DeviceDesiredStaus_update`
BEFORE UPDATE ON `nccs`.`DeviceDesiredStaus`
FOR EACH ROW
begin
    if  (new. BrdMode is null and old.BrdMode is not null) or
         (new. BrdMode is not null and old.BrdMode is null) or
         (new. BrdMode != old.BrdMode) or 
         (new. ModePriority != old.ModePriority) then
        set new.SessionValid = false;
     end if;   
    
    if(old.IpCall <> new.IpCall) and (new.IpCall <> 0) then
        set new.IpCallEvent = now();
    end if;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`DeviceStatistic_after_insert` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`DeviceStatistic_after_insert`
AFTER INSERT ON `nccs`.`DeviceStatistic`
FOR EACH ROW
BEGIN
    if(new.`UsedTime` is not null) then
        set @newUsedTime =  CONV(SUBSTR(HEX(new.`UsedTime`), 9, 8), 16, 10);
        update DeviceList set ProjUsedTime = ProjUsedTime + @newUsedTime where DevID = new.DeviceID;
    end if;
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`DeviceStatistic_after_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`DeviceStatistic_after_update`
AFTER UPDATE ON `nccs`.`DeviceStatistic`
FOR EACH ROW
BEGIN
    if(old.`UsedTime` is null) then
        set @oldUsedTime = 0;
    else
        set @oldUsedTime =  CONV(SUBSTR(HEX(old.`UsedTime`), 9, 8), 16, 10);
    end if;
    if(new.`UsedTime` is null) then
        set @newUsedTime = 0;
    else
        set @newUsedTime =  CONV(SUBSTR(HEX(new.`UsedTime`), 9, 8), 16, 10);
    end if;
    if(@newUsedTime <> @oldUsedTime) then
        update DeviceList set ProjUsedTime = ProjUsedTime + (@newUsedTime - @oldUsedTime) where DevID = new.DeviceID;
    end if;
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_dev_changed1` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_dev_changed1`
AFTER UPDATE ON `nccs`.`DeviceStatus`
FOR EACH ROW
begin

	insert into Messages Values (0, 1, 2, 3, now(), 0, 0, new.DeviceID, NULL);
	if (old.State_SysPower <> new.State_SysPower) then
		if (new.State_SysPower = 2) then 
			update DeviceLog set EndTime=now() where DeviceID=new.DeviceID and Event=3 order by DevLogID desc limit 1;
            if(old.State_SysPower=1) then 
				update DeviceLog set EndTime=now() where DeviceID=new.DeviceID and Event=2 order by DevLogID desc limit 1;
            end if;
			
		else
			if (old.State_SysPower = 2) then   
				insert into DeviceLog(`DeviceID`, `DateTime`, `Event`)  Values (new.DeviceID, now(), 3);
			else
				if(new.State_SysPower = 0) then 
					update DeviceLog set EndTime=now() where DeviceID=new.DeviceID and Event=2 order by DevLogID desc limit 1;
				else  
					insert into DeviceLog(`DeviceID`, `DateTime`, `Event`, `CtrlUser`)
						 Values (new.DeviceID, now(), 2, new.User_ID);
				end if;
			end if;
         end if;
        
      elseif (new.State_SysPower=1) and (new.User_ID is not null) then
            if(old.User_ID is null)  then
                update DeviceLog set CtrlUser=new.User_ID where DeviceID=new.DeviceID and Event=2 order by DevLogID desc limit 1;
            elseif(old.User_ID <> new.User_ID) then
              update DeviceLog set EndTime=now() where DeviceID=new.DeviceID and Event=2 order by DevLogID desc limit 1;
              insert into DeviceLog(`DeviceID`,`DateTime`,`Event`,`CtrlUser`)
                  Values (new.DeviceID, now(), 2, new.User_ID);
            end if;
      end if;

      if (old.State_ProjectorStatus <> new.State_ProjectorStatus) then
            if(new.State_ProjectorStatus = 1) then
                insert into DeviceLog(`DeviceID`, `DateTime`, `Event`)  Values (new.DeviceID, now(), 4);
            elseif(new.State_ProjectorStatus = 0) then
			    update DeviceLog set EndTime=now() where DeviceID=new.DeviceID and Event=4 order by DevLogID desc limit 1;
            end if;
      end if;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_dev_del` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_dev_del`
AFTER DELETE ON `nccs`.`DeviceStatus`
FOR EACH ROW
begin
    declare logID int default null;
	
    update IpCall set status='idle' where device = old.DeviceID;
    update DeviceDesiredStaus set SessionValid = false, IpCall = 0 where DeviceDesiredStaus.DeviceID = old.DeviceID;
	INSERT INTO Messages Values (0, 1, 2, 3, now(), 0, 0, old.DeviceID, NULL);

	update DeviceLog set EndTime=now() where DeviceID=old.DeviceID and Event=1 order by DevLogID desc limit 1;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_dev_instert` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_dev_instert`
AFTER INSERT ON `nccs`.`DeviceStatus`
FOR EACH ROW
begin
     
     
     call sp_send_dev_ctrl_cmd(new.DeviceID, new.IpAddress, 55, 0, 0, 0, null);
     call sp_send_dev_ctrl_cmd(new.DeviceID, new.IpAddress, 56, 0, 0, 0, null);
     call sp_send_dev_ctrl_cmd(new.DeviceID, new.IpAddress, 112, 0, 0, 0, null);

     insert into DeviceLog(`DeviceID`, `DateTime`, `Event`)  Values (new.DeviceID, now(), 1);
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_devstatus_before_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_devstatus_before_update`
BEFORE UPDATE ON `nccs`.`DeviceStatus`
FOR EACH ROW
BEGIN
    declare uid int default null;
    declare ret int default null;

    if(new.State_SysPower<>1) and (old.State_SysPower = 1) then
		set new.User_ID = null;
    elseif(old.User_ID is not null) and (new.User_ID is null) then
        set new.User_ID = old.User_ID;
    end if;
    if(new.SysPowerCmd is not null) and (new.State_SysPower <> 2)then
        select sp_send_dev_ctrl_function(NULL, new.DeviceID, new.IpAddress, 48, new.SysPowerCmd, 0, 0, NULL) into ret ;
        set new.SysPowerCmd = NULL;
    end if;
    if(old.IpAddress is null) and (new.IpAddress is not null) then
        call sp_send_dev_ctrl_cmd(new.DeviceID, new.IpAddress, 112, 0, 0, 0, null);
    end if;
    if(new.Temperature is not null) then
        set new.Temperature = (new.Temperature & 0xc000) + (ROUND((new.Temperature & 0x3fff) / 10) * 10);
    end if;
    if(new.Humidity is not null) then
        set new.Humidity = (new.Humidity & 0xc000) + (ROUND((new.Humidity & 0x3fff) / 10) * 10);
    end if;
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_player_delete` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_player_delete`
BEFORE DELETE ON `nccs`.`Players`
FOR EACH ROW
begin


delete from PlayerKeys where PlayerID = old.PlayerID;

delete from PlaySessions where PlayerID = old.PlayerID;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_player_insert` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_player_insert`
AFTER INSERT ON `nccs`.`Players`
FOR EACH ROW
begin
    if (new.PlayerType = 10) then
	    insert into   PlaySessions(SessionID, SessionType, PlayerID, Priority, SessionName, StreamType)
            values (get_idle_sessionid(false), new.PlayerType, new.PlayerID, new.Priority, new.PlayerID, 3);
    elseif ((new.PlayerType <> 0) and (new.PlayerType <> 8)) then
	    insert into   PlaySessions(SessionID, SessionType, PlayerID, Priority, SessionName)
            values (get_idle_sessionid(false), new.PlayerType, new.PlayerID, new.Priority, new.PlayerID);
    end if;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_user_delete` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_user_delete`
BEFORE DELETE ON `nccs`.`Users`
FOR EACH ROW
begin
	declare tmp_mediaid int default 0;
	
	select MediaID into tmp_mediaid from MediaFiles where `Owner` = Old.User_ID and Sysfolder = 1;
	if((tmp_mediaid is not null) and tmp_mediaid <> 0) then
		set max_sp_recursion_depth=10;
		call sp_del_media_file(Old.User_ID,tmp_mediaid); 
	end if;

        delete from UserDevices where UserID = old.User_ID;
        
		delete PlaySessionTime from PlaySessionTime, PlaySessions  
               where PlaySessions.Owner = old.User_ID and PlaySessionTime. SessionID = PlaySessions.SessionID;
	delete from PlaySessions where Owner = old.User_ID;
	delete from MediaFiles where Owner = Old.User_ID;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_user_delete_player` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_user_delete_player`
AFTER DELETE ON `nccs`.`Users`
FOR EACH ROW
begin
    delete from Players where PlayerID = old.UsbKey;
    if(old.User_Name is not null) then
        insert into BaseInfo (InfomationID, InfoValue) values (341, 0) on duplicate key update InfoValue = InfoValue + 1;
    end if;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_user_insert` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_user_insert`
AFTER INSERT ON `nccs`.`Users`
FOR EACH ROW
begin
	declare tmp_mediaid int default 0;

    if (new.UsbKey is not null) then 
        
        
		update PlaySessions set Owner = new.User_ID, SessionType = 1 where (PlaySessions.PlayerID = new.UsbKey);
    end if;

	if ((new.Priority > 0) and (new.privilege & 0x100) <> 0 and (new.User_Name is not null))  then 
        
		
		select MediaID into tmp_mediaid from MediaFiles where Sysfolder=2;

		if((tmp_mediaid is not null) and tmp_mediaid <> 0) then
			insert into MediaFiles(FileName,FileSize,TotalTime,FileFmt,BitRate,VedioCodec,
				Height,Width,FrameRate,AudioCodec,Channels,SampleRate,Gain,CreateTime,Parent,`Owner`,Sysfolder) values(
				new.User_Desc,0,0,0,0,0,0,0,0,0,0,0,0,now(),tmp_mediaid,new.User_ID,1);
		else
			insert into MediaFiles(FileName,FileSize,TotalTime,FileFmt,BitRate,VedioCodec,
				Height,Width,FrameRate,AudioCodec,Channels,SampleRate,Gain,CreateTime,Sysfolder) values(
				'用户文件',0,0,0,0,0,0,0,0,0,0,0,0,now(),2);

			select MediaID into tmp_mediaid from MediaFiles where Sysfolder=2;

			insert into MediaFiles(FileName,FileSize,TotalTime,FileFmt,BitRate,VedioCodec,
				Height,Width,FrameRate,AudioCodec,Channels,SampleRate,Gain,CreateTime,Parent,`Owner`,Sysfolder) values(
				new.User_Desc,0,0,0,0,0,0,0,0,0,0,0,0,now(),tmp_mediaid,new.User_ID,1);
		end if;
		
	end if;
    if(new.`User_Name` is not null) and (new.`Pass_Word` is not null) then
        insert into BaseInfo (InfomationID, InfoValue) values (341, 0) on duplicate key update InfoValue = InfoValue + 1;
    end if;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_user_insert_player` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_user_insert_player`
BEFORE INSERT ON `nccs`.`Users`
FOR EACH ROW
begin
    if (new.privilege & 0x01 = 0x01) then
        set new.privilege = new.privilege | 0x10000;
    else
        set new.privilege = new.privilege & 0xfffeffff;
    end if;

    if (new.UsbKey is not null) then 
        
        insert into Players(PlayerID, PlayerType, Priority ) values (new.UsbKey, 2, new.Priority) ;
    end if;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_user_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_user_update`
AFTER UPDATE ON `nccs`.`Users`
FOR EACH ROW
begin
	declare tmp_root_mediaid int default 0;
	declare tmp_mediaid int default 0;

    if ((new.UsbKey is not null) and (old.UsbKey is null)) or
       ((old.UsbKey is not null) and (new.UsbKey is null)) or 
       (old.UsbKey <> new.UsbKey) then 
        delete from Players where PlayerID = old.UsbKey;

       
        if (new.UsbKey is not null) then 
            
			update PlaySessions set Owner = new.User_ID, SessionType = 1 where (PlaySessions.PlayerID = new.UsbKey);
        end if;

    end if;

    if (new.Priority <> old.Priority) then
        update PlaySessions set  Priority = new.Priority 
               where PlaySessions.Owner = new.User_ID;
    end if;

	if ((new.privilege & 0x01) = 0) then 
        
		delete PlaySessionTime from PlaySessionTime, PlaySessions  
               where PlaySessions.Owner = old.User_ID and 
					 PlaySessionTime. SessionID = PlaySessions.SessionID and 
                     (SysEnabled is not null);
    end if;

	if ((new.privilege & 0x100) = 0)  then 
        
        delete PlaySessionTime from PlaySessionTime, PlaySessions  
               where PlaySessions.Owner = old.User_ID and 
					 PlaySessionTime. SessionID = PlaySessions.SessionID and 
                     (PlaySessions.StreamType <> 0);

		
		select MediaID into tmp_mediaid from MediaFiles where `Owner` = new.User_ID and Sysfolder = 1;
		if((tmp_mediaid is not null) and tmp_mediaid <> 0) then
			set max_sp_recursion_depth=10;
			call sp_del_media_file(new.User_ID,tmp_mediaid); 
		end if;
	else
		if(new.Priority > 0) then
			
			select MediaID into tmp_root_mediaid from MediaFiles where Sysfolder = 2;

			if((tmp_root_mediaid is not null) and tmp_root_mediaid <> 0) then

				select MediaID into tmp_mediaid from MediaFiles where `Owner` = new.User_ID and Sysfolder = 1;
				
				if((tmp_mediaid is not null) and tmp_mediaid <> 0) then
					if(new.User_Desc <> Old.User_Desc) then
						update MediaFiles set FileName=new.User_Desc where MediaID = tmp_mediaid;
					end if;
				else
					insert into MediaFiles(FileName,FileSize,TotalTime,FileFmt,BitRate,VedioCodec,
						Height,Width,FrameRate,AudioCodec,Channels,SampleRate,Gain,CreateTime,Parent,`Owner`,Sysfolder) values(
						new.User_Desc,0,0,0,0,0,0,0,0,0,0,0,0,now(),tmp_root_mediaid,new.User_ID,1);
				end if;
				
			else
				insert into MediaFiles(FileName,FileSize,TotalTime,FileFmt,BitRate,VedioCodec,
					Height,Width,FrameRate,AudioCodec,Channels,SampleRate,Gain,CreateTime,Sysfolder) values(
					'用户文件',0,0,0,0,0,0,0,0,0,0,0,0,now(),2);

				select MediaID into tmp_root_mediaid from MediaFiles where Sysfolder = 2;

				insert into MediaFiles(FileName,FileSize,TotalTime,FileFmt,BitRate,VedioCodec,
					Height,Width,FrameRate,AudioCodec,Channels,SampleRate,Gain,CreateTime,Parent,`Owner`,Sysfolder) values(
					new.User_Desc,0,0,0,0,0,0,0,0,0,0,0,0,now(),tmp_root_mediaid,new.User_ID,1);
			end if;
		end if;
    end if;

	if ((new.privilege & 0x10000) = 0)  then 
        
        delete PlaySessionTime from PlaySessionTime, PlaySessions  
               where PlaySessions.Owner = old.User_ID and 
					 PlaySessionTime. SessionID = PlaySessions.SessionID and 
                     (RfDevCtrl is not null) and (RfDevCtrl <> 0x00000000000000000000000000000000);
    end if;

    if (((new.IcCard is not null) and (old.IcCard is null)) or
       ((new.IcCard is null) and (old.IcCard is not null)) or
       (old.IcCard <> new.IcCard)) then 
           update UserDevices set UserID = new.User_ID where UserID = new.User_ID;
    end if;
    if(new.Dev_Privilege = 1) and (old.Dev_Privilege <> 1) then
        update UserDevices set Pri = Pri & 0xfe where UserID=new.User_ID;
        delete from UserDevices where Pri = 0;
    end if;

    if(new.Mgr_Privilege = 1) and (old.Mgr_Privilege <> 1) then
        update UserDevices set Pri = Pri & 0xfd where UserID=new.User_ID;
        delete from UserDevices where Pri = 0;
    end if;
    if(not((old.User_Name is null) and (new.User_Name is null)) or
       ((isnull(old.UnionId) and not isnull(new.UnionId)) or (not isnull(old.UnionId) and isnull(new.UnionId)))) then
        insert into BaseInfo (InfomationID, InfoValue) values (341, 0) on duplicate key update InfoValue = InfoValue + 1;
    end if;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_user_update_player` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_user_update_player`
BEFORE UPDATE ON `nccs`.`Users`
FOR EACH ROW
begin
    if (new.privilege & 0x01 = 0x01) then
        set new.privilege = new.privilege | 0x10000;
    else
        set new.privilege = new.privilege & 0xfffeffff;
    end if;

    if ((new.UsbKey is not null) and (old.UsbKey is null)) or
       (old.UsbKey <> new.UsbKey) then 
	    insert into Players(PlayerID, PlayerType, Priority ) values (new.UsbKey, 2, new.Priority);
    end if;
    
    if (old.ServerSync is null) or (old.ServerSync <> 1) then
        set new.ServerSync = 1; 
    end if;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_TaskTemplate_delete` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_TaskTemplate_delete`
BEFORE DELETE ON `nccs`.`TaskTemplate`
FOR EACH ROW
begin
	delete from PlaySessions where Template = old.idTaskTemplate;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_session_delete` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`localhost`
TRIGGER `nccs`.`tr_session_delete`
BEFORE DELETE ON `nccs`.`PlaySessions`
FOR EACH ROW
begin
	 
	 update PlayerStatus set SessionID = 0 where (SessionID = old.SessionID);
     
     delete from PlayListFiles where SessionID = old.SessionID;
     delete from SessionDevice where SessionID = old.SessionID;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_session_insert` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_session_insert`
BEFORE INSERT ON `nccs`.`PlaySessions`
FOR EACH ROW
begin
     declare count int default 0;
     declare parentid int default 0;
     declare Sestype int default 0;
     declare mode_priority int default null;
     declare templateId int default 0;
     
     set parentid = new.Parent;
     
     while (parentid is not null)  and (parentid <> 0) and (count < 5) do
      select Parent , SessionType into parentid, Sestype from  PlaySessions where SessionID = parentid;
      if (Sestype = 127) then
            set count = count + 1;
        else
           set count =  5;
         end if;
         
     end while;
     
     if (count >= 5) then 
     insert PlaySessions(SessionID) values(0);
     end if;
     
     if (new.BrdMode > 0) then
		     select Priority into mode_priority from BroadcastMode where idBroadcastMode = new.BrdMode;
		     if (new.Priority > mode_priority) then
		         set new.Priority = mode_priority;
		     end if;
     end if;

     if (func_check_task_privilege(new.Owner, new.StreamType, new.SysEnabled, new.RfDevCtrl) = false) then
        insert PlaySessions(SessionID) values(0);
     end if;
    if (new.SessionType = 10) or (new.SessionType = 1) or (new.SessionType = 2) then
        set new.Template = null;
    
    elseif (new.Template is null) and (new.Owner is null) then
        select InfoValue into templateId from BaseInfo where InfomationID=257;
        set new.Template = templateId;
    end if;

end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_session_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`localhost`
TRIGGER `nccs`.`tr_session_update`
BEFORE UPDATE ON `nccs`.`PlaySessions`
FOR EACH ROW
begin
     declare count int default 0;
     declare parentid int default 0;
     declare Sestype int default 0;
     declare mode_priority int default null;
     
     set parentid = new.Parent;
     
     while (parentid is not null)  and (parentid <> 0) and (count < 5) do
        select Parent , SessionType into parentid, Sestype from  PlaySessions where SessionID = parentid;
         if (Sestype = 127) then
            set count = count + 1;
        else
           set count =  5;
         end if;
     end while;
     
     if (count >= 5) then 
         insert PlaySessions(SessionID) values(0);
     end if;
     
     if (func_check_task_privilege(new.Owner, new.StreamType, new.SysEnabled, new.RfDevCtrl) = false) then
        insert PlaySessions(SessionID) values(0);
     end if;

     if (new.BrdMode > 0) then
		     select Priority into mode_priority from BroadcastMode where idBroadcastMode = new.BrdMode;
		     if (new.Priority > mode_priority) then
		         set new.Priority = mode_priority;
		     end if;
     end if;
     
     
     if (new.Priority <> old.Priority) then
         update DeviceDesiredStaus, SessionDevice set  DeviceDesiredStaus.SessionValid = false 
                 where DeviceDesiredStaus.DeviceID = SessionDevice.DeviceID and
                                SessionDevice.SessionID = new.SessionID;
                                
          update DeviceDesiredStaus, PlayerKeys set  DeviceDesiredStaus.SessionValid = false 
                 where PlayerKeys.PlayerID = new.PlayerID and 
                                PlayerKeys.GroupDisable = 0 and
                                PlayerKeys.GroupID is not null and 
                                sp_dev_belong_group(DeviceDesiredStaus. DeviceID, PlayerKeys.GroupID);
     end if;
     
     if (new.MemberMode <> old.MemberMode) then
         if (new.MemberMode = true) then
             delete from SessionDevice where SessionID = new.SessionID;
          end if; 
      
          if (new.BrdMode <> 0) then
               update DeviceDesiredStaus, BrdModeMember set  DeviceDesiredStaus.SessionValid = false 
                   where DeviceDesiredStaus.DeviceID =  BrdModeMember.DeviceID and
                                 BrdModeMember.BrdModeID <> new.BrdMode;
          end if;
      end if;      
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_play_Schedule_delete` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_play_Schedule_delete`
BEFORE DELETE ON `nccs`.`PlaySessionTime`
FOR EACH ROW
begin
 INSERT INTO Messages Values (0, 1, 2, 10, now(), 0, old.ScheduleID, null, null);
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_play_Schedule_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_play_Schedule_update`
AFTER UPDATE ON `nccs`.`PlaySessionTime`
FOR EACH ROW
begin
 INSERT INTO Messages Values (0, 1, 2, 10, now(), 0, new.ScheduleID, null, null);
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`Event_before_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`Event_before_update`
BEFORE UPDATE ON `nccs`.`Event`
FOR EACH ROW
BEGIN
    if(new.Version >= 0) then
        set new.Version = old.Version + 1; 
    end if;
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`IpCall_after_delete` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`IpCall_after_delete`
AFTER DELETE ON `nccs`.`IpCall`
FOR EACH ROW
BEGIN
    if(old.status <> 'idle') then
        update DeviceDesiredStaus set IpCall = (case `listen` when 0 then 3 else 0 end) where DeviceID=old.device;
    end if;
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`IpCall_after_insert` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`IpCall_after_insert`
AFTER INSERT ON `nccs`.`IpCall`
FOR EACH ROW
BEGIN
    declare ecode int;
    select sys_exec(concat('iDsteWebrtc ', new.id, '&')) into ecode;
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`IpCall_before_insert` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`IpCall_before_insert`
BEFORE INSERT ON `nccs`.`IpCall`
FOR EACH ROW
BEGIN
    declare idle_port int default 8500;
    set new.ringing = now();
    set new.status='ringing';
    set new.webrtcStatus = 'idle';
    set new.webrtcUpdate = null;
    
    _loop: loop   
    if not exists(select * from IpCall where audioPort = idle_port) then   
        leave _loop;
    end if;
    set idle_port = idle_port + 2;
    end loop;
    
    set new.audioPort = idle_port;
    set new.wsPort = idle_port + 1;
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`IpCall_before_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`IpCall_before_update`
BEFORE UPDATE ON `nccs`.`IpCall`
FOR EACH ROW
BEGIN
    declare err int default null;
    declare deviceUser int default null; 

    
    if((old.webrtcStatus <> 'error') and (new.webrtcStatus = 'error')) or 
      ((old.webrtcStatus <> 'idle') and (new.webrtcStatus = 'idle')) then
        set new.status = 'idle';
    elseif(old.webrtcStatus <> 'running') and (new.webrtcStatus = 'running') then
        set new.status = 'talking';
    end if;

    if(new.status = 'idle') and (old.status <> 'idle') then
        
        select User_ID into deviceUser from DeviceStatus where DeviceID = old.device;
        if(old.direction = 'b2s') then
            insert into DeviceLog (`DeviceID`, `DateTime`, `Event`, `CtrlUser`, `EndTime`)
                values(old.device, old.ringing, 5, deviceUser, now());
        else
            insert into DeviceLog (`DeviceID`, `DateTime`, `Event`, `CtrlUser`, `EndTime`)
                values(old.device, old.ringing, 6, deviceUser, now());
        end if;
        
        update DeviceDesiredStaus set IpCall=
            (
                case new.`listen` when 0 then
                    case `IpCall` when 2 then 3
                    when 1 then 3
                    else 0
                    end
                else 0
                end
            ), IpCallPort=0 
        where DeviceID = new.device;
    elseif(new.status = 'talking') and (old.status <> 'talking') then
        update DeviceDesiredStaus set IpCall=(case new.`listen` when 0 then 2 else 4 end),IpCallPort=new.audioPort where DeviceID = new.device;
    end if;
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`bef_media_delete` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`bef_media_delete`
BEFORE DELETE ON `nccs`.`MediaFiles`
FOR EACH ROW
begin
	if(Old.Sysfolder = 2) then
		
		insert MediaFiles(MediaID) values(0);
	end if;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`bef_media_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`bef_media_update`
BEFORE UPDATE ON `nccs`.`MediaFiles`
FOR EACH ROW
begin
	declare tmp_root_mediaid int default 0;

	if(new.Sysfolder = 2 ) then
		
		insert MediaFiles(MediaID) values(0);
	end if;

	select MediaID into tmp_root_mediaid from MediaFiles where Sysfolder = 2 limit 1;
	if((tmp_root_mediaid is not null) and tmp_root_mediaid <> 0) then
		
		if((new.Parent = tmp_root_mediaid) and (new.Sysfolder is null or new.Sysfolder <> 1)) then			
			insert MediaFiles(MediaID) values(0);
		end if;

		
		if((new.Sysfolder = 1) and (new.Parent <> tmp_root_mediaid)) then			
			insert MediaFiles(MediaID) values(0);
		end if;

	end if;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_media_after_delete` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_media_after_delete`
AFTER DELETE ON `nccs`.`MediaFiles`
FOR EACH ROW
begin
	if(Old.TotalTime <> 0 and Old.FileFmt <> -1 and (Old.FilePath is not null and Old.FilePath!="")) then
		insert into tmp_DelMediaFiles(filepath) values(Old.FilePath);
	end if;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_media_insert` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_media_insert`
BEFORE INSERT ON `nccs`.`MediaFiles`
FOR EACH ROW
begin
     declare count int default 0;
     declare parentid int default 0;
     declare nodetype int default 0;

     set parentid = new.Parent;
     
     while (parentid is not null)  and (parentid <> 0) and (count < 5) do
      select Parent , TotalTime into parentid, nodetype from  MediaFiles where MediaID = parentid;
      if ((nodetype = 0)  or (nodetype is null)) then
            set count = count + 1;
        else
           set count =  5;
         end if;
         
     end while;
     
     if ((count >= 5) or (count = 4 and new.TotalTime = 0)) then 
     insert MediaFiles(MediaID) values(0);
     end if;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_media_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`localhost`
TRIGGER `nccs`.`tr_media_update`
AFTER UPDATE ON `nccs`.`MediaFiles`
FOR EACH ROW
begin
     declare count int default 0;
     declare parentid int default 0;
     declare nodetype int default 0;
     
     set parentid = new.Parent;
     
     while (parentid is not null)  and (parentid <> 0) and (count < 5) do
        select Parent , TotalTime into parentid, nodetype from  MediaFiles where MediaID = parentid;
        if ((nodetype = 0)  or (nodetype is null)) then
            set count = count + 1;
        else
           set count =  5;
         end if;
     end while;
     
     if (count >= 5) then 
     insert MediaFiles(MediaID) values(0);
     end if;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`PlayerAlive_after_delete` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`localhost`
TRIGGER `nccs`.`PlayerAlive_after_delete`
AFTER DELETE ON `nccs`.`PlayerAlive`
FOR EACH ROW
BEGIN
    update DeviceLog 
        set EndTime=now() 
            where DeviceID=old.PlayerID 
                and Event=1 
            order by DevLogID desc limit 1;
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`PlayerAlive_after_insert` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`localhost`
TRIGGER `nccs`.`PlayerAlive_after_insert`
AFTER INSERT ON `nccs`.`PlayerAlive`
FOR EACH ROW
BEGIN 
    insert into DeviceLog (`DeviceID`, `DateTime`,  `Event`) 
        values (new.PlayerID, now(), 1);
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_PlayerKeys_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_PlayerKeys_update`
AFTER UPDATE ON `nccs`.`PlayerKeys`
FOR EACH ROW
begin                               
     update DeviceDesiredStaus set  DeviceDesiredStaus.SessionValid = false 
                 where old.GroupID is not null and sp_dev_belong_group(DeviceDesiredStaus. DeviceID, old.GroupID);  
                 
    if not (new.GroupID = old.GroupID) then
           update DeviceDesiredStaus set  DeviceDesiredStaus.SessionValid = false 
                 where new.GroupID is not null  and sp_dev_belong_group(DeviceDesiredStaus. DeviceID, new.GroupID);
     end if;            
    
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_playerstatus_delete` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_playerstatus_delete`
BEFORE DELETE ON `nccs`.`PlayerStatus`
FOR EACH ROW
begin
    delete from PlayingSessions where SessionID = old.SessionID;   
    
    insert into Messages Values (0, 1, 2, 3, now(), 0, 0, old.PlayerID, NULL);
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_playerstatus_insert` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_playerstatus_insert`
AFTER INSERT ON `nccs`.`PlayerStatus`
FOR EACH ROW
begin    
    insert into Messages Values (0, 1, 2, 3, now(), 0, 0, new.PlayerID, NULL);
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_playerstatus_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_playerstatus_update`
BEFORE UPDATE ON `nccs`.`PlayerStatus`
FOR EACH ROW
begin

if (new.SessionID is null) or (new.SessionID  = 0) then
    delete from PlayingSessions where SessionID = old.SessionID;
    if(old.SessionID > 0) then
        set new.ScheduleID=null;
    end if;
    
    
     if ((new.PlayType <> 0) and (new.PlayType <> 8) and (new.ActualSesID <> 0))  then
        call sp_send_dev_ctrl_cmd(new.PlayerID, new.IpAddress, 133, new.ActualSesID, 0, 0, null);
    end if ;    
 else
     insert into PlayingSessions(SessionID, PlayerID, Priority, MultiPort, CircleLength, ScheduleID, BrdMode, SesType, StreamType)
            select  a.SessionID, b.PlayerID, a.Priority, new.PlayPort,
                           case when (a.SessionType = 10 and c.Length is not null) then c.Length else a.CircleLength end,
                           new.ScheduleID, a.BrdMode, a.SessionType, a.StreamType
                           from PlaySessions a, Players b
                           left join PlaySessionTime c on c.ScheduleID = new.ScheduleID
                           where b.PlayerID = new.PlayerID and a.SessionID = new.SessionID
            on duplicate key update PlayerID = values(PlayerID) , Priority = values(Priority) , 
                         MultiPort = values(MultiPort) , CircleLength = values(CircleLength) ,
                         ScheduleID = values(ScheduleID) , BrdMode = values(BrdMode),
                         SesType = values(SesType), StreamType = values(StreamType);
            
     if (not new.SessionID = new.ActualSesID)  and (new.PlayType <> 0) and (new.PlayType <> 8)  then
            call sp_send_dev_ctrl_cmd(new.PlayerID, new.IpAddress, 131, new.SessionID, 
                                      8064, get_srv_ip(),
                                      (select SessionName from PlaySessions where PlayerID=new.PlayerID limit 1));
     end if;         
end if;    
 
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_playerstatus_update_a` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_playerstatus_update_a`
AFTER UPDATE ON `nccs`.`PlayerStatus`
FOR EACH ROW
begin    
    insert into Messages Values (0, 1, 2, 3, now(), 0, 0, new.PlayerID, NULL);
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_playing_ses_del` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_playing_ses_del`
AFTER DELETE ON `nccs`.`PlayingSessions`
FOR EACH ROW
begin
     INSERT INTO Messages Values (0, 1, 2, 10, now(), old.SessionID, old.ScheduleID, null, null);
     delete from PlaySessionTime where PlaySessionTime.ScheduleID = old.ScheduleID and TempFlag = 1;
     
    update DeviceDesiredStaus set  DeviceDesiredStaus.SessionValid = false 
           where  DeviceDesiredStaus.SessionID = old.SessionID;
    if(old.SesType = 10) then
        select PlayerStatus.IpAddress, PlaySessions.PlayerID into @ip, @player from PlayerStatus 
            inner join PlaySessions on PlaySessions.PlayerID = PlayerStatus.PlayerID
            where PlaySessions.SessionID = old.SessionID;
        if(@ip is not null) and (@player is not null) then
            call sp_send_dev_ctrl_cmd(@player, @ip, 48, 0, 0, 0, null);
        end if;
    end if;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_playing_ses_ins` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_playing_ses_ins`
AFTER INSERT ON `nccs`.`PlayingSessions`
FOR EACH ROW
begin
     INSERT INTO Messages Values (0, 1, 2, 10, now(), new.SessionID, new.ScheduleID, null, null);
     
     if (new.BrdMode > 0) then
          update DeviceDesiredStaus set  DeviceDesiredStaus.SessionValid = false  where DeviceDesiredStaus.BrdMode = new.BrdMode;
      end if;

      update DeviceDesiredStaus, SessionDevice set  DeviceDesiredStaus.SessionValid = false 
                 where DeviceDesiredStaus.DeviceID = SessionDevice.DeviceID and
                                SessionDevice.SessionID = new.SessionID;
      
      update DeviceDesiredStaus, PlayerKeys set  DeviceDesiredStaus.SessionValid = false 
                 where PlayerKeys.PlayerID = new.PlayerID and 
                                PlayerKeys.GroupDisable = 0 and
                                PlayerKeys.GroupID is not null and 
                                sp_dev_belong_group(DeviceDesiredStaus. DeviceID, PlayerKeys.GroupID);
                                
    
                 
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_playing_ses_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_playing_ses_update`
AFTER UPDATE ON `nccs`.`PlayingSessions`
FOR EACH ROW
begin
    if (new.Pause <> old.Pause) then
     INSERT INTO Messages Values (0, 1, 2, 10, now(), new.SessionID, new.ScheduleID, null, null);
     end if;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`PwrDisplaySet_ADEL` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`PwrDisplaySet_ADEL`
AFTER DELETE ON `nccs`.`PwrDisplaySet`
FOR EACH ROW
begin   
    declare ret integer;    
    select send_msg_to_srv(179, null) into ret;       
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`PwrDisplaySet_AINS` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`PwrDisplaySet_AINS`
AFTER INSERT ON `nccs`.`PwrDisplaySet`
FOR EACH ROW
begin   
    declare ret integer;    
    select send_msg_to_srv(179, null) into ret;       
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`PwrDisplaySet_AUPD` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`PwrDisplaySet_AUPD`
AFTER UPDATE ON `nccs`.`PwrDisplaySet`
FOR EACH ROW
begin   
    declare ret integer;    
    select send_msg_to_srv(179, null) into ret;       
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_ses_dev_ses_del` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_ses_dev_ses_del`
AFTER DELETE ON `nccs`.`SessionDevice`
FOR EACH ROW
begin 
    update DeviceDesiredStaus set  DeviceDesiredStaus.SessionValid = false  
               where  DeviceDesiredStaus.DeviceID = old.DeviceID and 
                              DeviceDesiredStaus.SessionID = old.SessionID;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_ses_dev_ses_ins` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_ses_dev_ses_ins`
AFTER INSERT ON `nccs`.`SessionDevice`
FOR EACH ROW
begin 
    update DeviceDesiredStaus set  DeviceDesiredStaus.SessionValid = false  where  DeviceDesiredStaus.DeviceID = new.DeviceID;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_ses_dev_ses_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_ses_dev_ses_update`
AFTER UPDATE ON `nccs`.`SessionDevice`
FOR EACH ROW
begin 
    update DeviceDesiredStaus set  DeviceDesiredStaus.SessionValid = false  
              where  DeviceDesiredStaus.DeviceID = new.DeviceID;
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`SrsServer_after_delete` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`SrsServer_after_delete`
AFTER DELETE ON `nccs`.`SrsServer`
FOR EACH ROW
BEGIN
    delete from SrsServerStatus where id=old.id; 
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`SrsServer_after_insert` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`SrsServer_after_insert`
AFTER INSERT ON `nccs`.`SrsServer`
FOR EACH ROW
BEGIN
    insert into SrsServerStatus values(new.id, new.`server`, 0); 
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`SrsServer_after_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`SrsServer_after_update`
AFTER UPDATE ON `nccs`.`SrsServer`
FOR EACH ROW
BEGIN
    update SrsServerStatus set `server` = new.`server`, count=0 where id = new.id; 
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`SrsServerStatus_before_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`SrsServerStatus_before_update`
BEFORE UPDATE ON `nccs`.`SrsServerStatus`
FOR EACH ROW
BEGIN
    if(new.count < 0) then
        set new.count = 0;
    end if;
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`SubNetwork_before_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`SubNetwork_before_update`
BEFORE UPDATE ON `nccs`.`SubNetwork`
FOR EACH ROW
BEGIN
	declare mask int unsigned default null;
    declare ip int unsigned default null;
	declare maskNew int unsigned default null;
    declare ipNew int unsigned default null;
    declare err int unsigned default null;
    declare finish boolean default false;
	declare tmp CURSOR for select inet_aton(`NetMask`), inet_aton(`IpAddress`) from SubNetwork
							where SubNetwork.`idSubNetwork` != new.idSubNetWork and
								  SubNetwork.`idSubNetwork` > 0 ;
    declare continue handler for NOT FOUND set finish = true;
    if (new.idSubNetwork > 0) then
        set maskNew = inet_aton(new.NetMask);
        set ipNew = inet_aton(new.IpAddress);
    
        if(((maskNew | (maskNew << 1)) & 0xffffffff) <> maskNew) or (maskNew = 0) then
    		select error_netmask into err from SubNetwork;
        end if;
    
        if(ipNew = 0) or (ipNew & maskNew = 0) then
    		select error_ip into err from SubNetwork;
        end if;
    
        open tmp;
        fetchloop:loop
    		fetch tmp into mask,ip;
            if(finish) then
    			leave fetchloop;
            end if;
            if(((ipNew&maskNew) = (ip&maskNew)) or
    			((ipNew&mask) = (ip&mask))) then
                close tmp;
                select error_ip_or_mask into err from SubNetWork;
    		end if;
        end loop;
        close tmp;
    end if;
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`SubNetwork_befroe_insert` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`SubNetwork_befroe_insert`
BEFORE INSERT ON `nccs`.`SubNetwork`
FOR EACH ROW
BEGIN
	declare mask int unsigned default null;
    declare ip int unsigned default null;
	declare maskNew int unsigned default null;
    declare ipNew int unsigned default null;
    declare err int unsigned default null;
    declare finish boolean default false;
	declare tmp CURSOR for select inet_aton(`NetMask`), inet_aton(`IpAddress`) from SubNetwork
							where SubNetwork.`idSubNetWork` > 0;
    declare continue handler for NOT FOUND set finish = true;

    if (new.idSubNetwork > 0) then
        set maskNew = inet_aton(new.NetMask);
        set ipNew = inet_aton(new.IpAddress);
    
        if(((maskNew | (maskNew << 1)) & 0xffffffff) <> maskNew) or (maskNew = 0) then
    		select error_netmask into err from SubNetwork;
        end if;
    
        if(ipNew = 0) or (ipNew & maskNew = 0) then
    		select error_ip into err from SubNetwork;
        end if;
    
        open tmp;
        fetchloop:loop
    		fetch tmp into mask,ip;
            if(finish) then
    			leave fetchloop;
            end if;
            if(((ipNew&maskNew) = (ip&maskNew)) or
    			((ipNew&mask) = (ip&mask))) then
                close tmp;
                select error_ip_or_mask into err from SubNetwork;
    		end if;
        end loop;
        close tmp;
    end if;
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`Timetable_before_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`Timetable_before_update`
BEFORE UPDATE ON `nccs`.`Timetable`
FOR EACH ROW
BEGIN
	declare err int default null;
    if (new.`WeekDay` < 0) and (new.`WeekDay` > 6) then
		select error_weekday_error into err from Timetable;
	end if;     
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`Timetable_befroe_insert` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`Timetable_befroe_insert`
BEFORE INSERT ON `nccs`.`Timetable`
FOR EACH ROW
BEGIN
	declare err int default null;
	if (new.`WeekDay` < 0) and (new.`WeekDay` > 6) then
		select error_weekday_error into err from Timetable;
	end if;    
END$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_userdev_delete` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_userdev_delete`
BEFORE DELETE ON `nccs`.`UserDevices`
FOR EACH ROW
begin
    
    declare ret integer;
    delete SessionDevice from SessionDevice, PlaySessions 
                        where PlaySessions.Owner = old.UserID and
                              SessionDevice.SessionID =  PlaySessions.SessionID and  
							  SessionDevice.DeviceID = old.DevID;

    select send_msg_to_srv(162, old.DevID) into ret;
       
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_usrdev_insert` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_usrdev_insert`
AFTER INSERT ON `nccs`.`UserDevices`
FOR EACH ROW
begin   
    declare ret integer;    
    select send_msg_to_srv(162, new.DevID) into ret;       
end$$


USE `nccs`$$
DROP TRIGGER IF EXISTS `nccs`.`tr_usrdev_update` $$
USE `nccs`$$
CREATE
DEFINER=`root`@`%`
TRIGGER `nccs`.`tr_usrdev_update`
AFTER UPDATE ON `nccs`.`UserDevices`
FOR EACH ROW
begin   
    declare ret integer;    
    select send_msg_to_srv(162, old.DevID) into ret;       
end$$


DELIMITER ;

SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
